program main
  ! Include methods for input/output channels
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  type(yggcomm) :: in_channel, out_channel
  integer(kind=c_size_t), target :: nrows
  type(character_1d), target :: name
  type(c_long_1d), target :: count
  type(real8_1d), target :: siz
  integer(kind=c_size_t) :: i

  ! initialize input/output channels
  in_channel = ygg_ascii_array_input("inputA")
  out_channel = ygg_ascii_array_output("outputA", "%6s\t%ld\t%f\n")

  ! Loop until there is no longer input or the queues are closed
  do while (flag)

     ! Receive input from input channel
     ! If there is an error, the flag will be negative
     ! Otherwise, it is the number of variables filled
     flag = ygg_recv_var_realloc(in_channel, [ &
          yggarg(nrows), yggarg(name), yggarg(count), yggarg(siz)])
     if (.not.flag) then
        print *, "Model A: No more input."
        exit
     end if

     ! Print received message
     print *, "Model A: (", nrows, " rows)"
     do i = 1, nrows
        print *, "   ", name%x(i)%x, count%x(i), siz%x(i)
     end do

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send_var(out_channel, [ &
          yggarg(nrows), yggarg(name), yggarg(count), yggarg(siz)])
     if (.not.flag) then
        print *, "Model A: Error sending output."
        exit
     end if

  end do

end program main

program main
  ! Include methods for input/output channels
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: flag = .true.
  type(yggcomm) :: in_channel, out_channel
  type(yggobj) :: p
  p = init_obj()

  ! initialize input/output channels
  in_channel = ygg_obj_input("inputB")
  out_channel = ygg_obj_output("outputB")

  ! Loop until there is no longer input or the queues are closed
  do while (flag)

     ! Receive input from input channel
     ! If there is an error, the flag will be negative
     ! Otherwise, it is the number of variables filled
     flag = ygg_recv_var(in_channel, yggarg(p))
     if (.not.flag) then
        print *, "Model B: No more input."
        exit
     end if

     ! Print received message
     print *, "Model B: (", p%nvert, " verts, ", p%nface, " faces)"
     call display_obj_indent(p, "  ")

     ! Send output to output channel
     ! If there is an error, the flag will be negative
     flag = ygg_send_var(out_channel, yggarg(p))
     if (.not.flag) then
        print *, "Model B: Error sending output."
        exit
     end if

  end do

end program main

module fygg

  ! TODO: Ensure that dynamically allocated C/C++ variables are freed.
  use iso_c_binding
  implicit none

  integer, parameter :: LINE_SIZE_MAX = 2048
  integer, parameter :: YGG_MSG_BUF = 2048
  integer, parameter :: ascii = selected_char_kind ("ascii")
#ifdef _WIN32
  integer, parameter :: ucs4  = 1
#else
  integer, parameter :: ucs4  = selected_char_kind ('ISO_10646')
#endif
  integer(kind=c_int), bind(c, name="YGG_MSG_MAX_F") :: YGG_MSG_MAX
  real(8),  parameter :: PI_8  = 4 * atan (1.0_8)
  real(16), parameter :: PI_16 = 4 * atan (1.0_16)

  interface yggarg
     module procedure yggarg_scalar_unsigned1
     module procedure yggarg_scalar_unsigned2
     module procedure yggarg_scalar_unsigned4
     module procedure yggarg_scalar_unsigned8
     module procedure yggarg_scalar_integer2
     module procedure yggarg_scalar_integer4
     module procedure yggarg_scalar_integer8
     module procedure yggarg_scalar_real4
     module procedure yggarg_scalar_real8
#ifndef _WIN32
     module procedure yggarg_scalar_real16
#endif
     module procedure yggarg_scalar_complex4
     module procedure yggarg_scalar_complex8
#ifndef _WIN32
     module procedure yggarg_scalar_complex16
#endif
     module procedure yggarg_scalar_logical1
     module procedure yggarg_scalar_logical2
     module procedure yggarg_scalar_logical4
     module procedure yggarg_scalar_logical8
     module procedure yggarg_scalar_character
#ifndef _WIN32
     module procedure yggarg_scalar_unicode
#endif
     module procedure yggarg_scalar_yggchar_r
     module procedure yggarg_scalar_ply
     module procedure yggarg_scalar_obj
     module procedure yggarg_scalar_null
     module procedure yggarg_scalar_generic
     module procedure yggarg_scalar_yggarr
     module procedure yggarg_scalar_yggmap
     module procedure yggarg_scalar_yggschema
     module procedure yggarg_scalar_yggpython
     module procedure yggarg_scalar_yggpyinst
     module procedure yggarg_scalar_yggpyfunc
     module procedure yggarg_scalar_yggptr
     ! module procedure yggarg_scalar_yggptr_arr
     ! module procedure yggarg_scalar_yggptr_map
     module procedure yggarg_realloc_1darray_unsigned1
     module procedure yggarg_realloc_1darray_unsigned2
     module procedure yggarg_realloc_1darray_unsigned4
     module procedure yggarg_realloc_1darray_unsigned8
     module procedure yggarg_realloc_1darray_c_long
     module procedure yggarg_realloc_1darray_integer
     module procedure yggarg_realloc_1darray_integer2
     module procedure yggarg_realloc_1darray_integer4
     module procedure yggarg_realloc_1darray_integer8
     module procedure yggarg_realloc_1darray_real
     module procedure yggarg_realloc_1darray_real4
     module procedure yggarg_realloc_1darray_real8
     module procedure yggarg_realloc_1darray_real16
     module procedure yggarg_realloc_1darray_complex
     module procedure yggarg_realloc_1darray_complex4
     module procedure yggarg_realloc_1darray_complex8
     module procedure yggarg_realloc_1darray_complex16
     module procedure yggarg_realloc_1darray_logical
     module procedure yggarg_realloc_1darray_logical1
     module procedure yggarg_realloc_1darray_logical2
     module procedure yggarg_realloc_1darray_logical4
     module procedure yggarg_realloc_1darray_logical8
     module procedure yggarg_realloc_1darray_character
     module procedure yggarg_1darray_unsigned1
     module procedure yggarg_1darray_unsigned2
     module procedure yggarg_1darray_unsigned4
     module procedure yggarg_1darray_unsigned8
     module procedure yggarg_1darray_integer2
     module procedure yggarg_1darray_integer4
     module procedure yggarg_1darray_integer8
     module procedure yggarg_1darray_real4
     module procedure yggarg_1darray_real8
#ifndef _WIN32
     module procedure yggarg_1darray_real16
#endif
     module procedure yggarg_1darray_complex4
     module procedure yggarg_1darray_complex8
#ifndef _WIN32
     module procedure yggarg_1darray_complex16
#endif
     module procedure yggarg_1darray_logical1
     module procedure yggarg_1darray_logical2
     module procedure yggarg_1darray_logical4
     module procedure yggarg_1darray_logical8
     module procedure yggarg_1darray_character
#ifndef _WIN32
     module procedure yggarg_1darray_unicode
#endif
     module procedure yggarg_1darray_yggchar_r
     module procedure yggarg_realloc_ndarray_unsigned1
     module procedure yggarg_realloc_ndarray_unsigned2
     module procedure yggarg_realloc_ndarray_unsigned4
     module procedure yggarg_realloc_ndarray_unsigned8
     module procedure yggarg_realloc_ndarray_c_long
     module procedure yggarg_realloc_ndarray_integer
     module procedure yggarg_realloc_ndarray_integer2
     module procedure yggarg_realloc_ndarray_integer4
     module procedure yggarg_realloc_ndarray_integer8
     module procedure yggarg_realloc_ndarray_real
     module procedure yggarg_realloc_ndarray_real4
     module procedure yggarg_realloc_ndarray_real8
     module procedure yggarg_realloc_ndarray_real16
     module procedure yggarg_realloc_ndarray_complex
     module procedure yggarg_realloc_ndarray_complex4
     module procedure yggarg_realloc_ndarray_complex8
     module procedure yggarg_realloc_ndarray_complex16
     module procedure yggarg_realloc_ndarray_logical
     module procedure yggarg_realloc_ndarray_logical1
     module procedure yggarg_realloc_ndarray_logical2
     module procedure yggarg_realloc_ndarray_logical4
     module procedure yggarg_realloc_ndarray_logical8
     module procedure yggarg_realloc_ndarray_character
     module procedure yggarg_2darray_unsigned1
     module procedure yggarg_2darray_unsigned2
     module procedure yggarg_2darray_unsigned4
     module procedure yggarg_2darray_unsigned8
     module procedure yggarg_2darray_integer2
     module procedure yggarg_2darray_integer4
     module procedure yggarg_2darray_integer8
     module procedure yggarg_2darray_real4
     module procedure yggarg_2darray_real8
#ifndef _WIN32
     module procedure yggarg_2darray_real16
#endif
     module procedure yggarg_2darray_complex4
     module procedure yggarg_2darray_complex8
#ifndef _WIN32
     module procedure yggarg_2darray_complex16
#endif
     module procedure yggarg_2darray_logical1
     module procedure yggarg_2darray_logical2
     module procedure yggarg_2darray_logical4
     module procedure yggarg_2darray_logical8
     module procedure yggarg_2darray_character
     module procedure yggarg_2darray_yggchar_r
  end interface yggarg
  interface generic_array_set
     module procedure generic_array_set_generic
     module procedure generic_array_set_boolean
     ! module procedure generic_array_set_integer
     module procedure generic_array_set_null
     ! module procedure generic_array_set_number
     module procedure generic_array_set_array
     module procedure generic_array_set_map
     module procedure generic_array_set_ply
     module procedure generic_array_set_obj
     module procedure generic_array_set_python_class
     ! module procedure generic_array_set_python_function
     module procedure generic_array_set_schema
     ! module procedure generic_array_set_any
     module procedure generic_array_set_integer2
     module procedure generic_array_set_integer4
     module procedure generic_array_set_integer8
     module procedure generic_array_set_unsigned1
     module procedure generic_array_set_unsigned2
     module procedure generic_array_set_unsigned4
     module procedure generic_array_set_unsigned8
     module procedure generic_array_set_real4
     module procedure generic_array_set_real8
     module procedure generic_array_set_complex4
     module procedure generic_array_set_complex8
     module procedure generic_array_set_bytes
     module procedure generic_array_set_unicode
     module procedure generic_array_set_1darray_integer2
     module procedure generic_array_set_1darray_integer4
     module procedure generic_array_set_1darray_integer8
     module procedure generic_array_set_1darray_unsigned1
     module procedure generic_array_set_1darray_unsigned2
     module procedure generic_array_set_1darray_unsigned4
     module procedure generic_array_set_1darray_unsigned8
     module procedure generic_array_set_1darray_real4
     module procedure generic_array_set_1darray_real8
     module procedure generic_array_set_1darray_complex4
     module procedure generic_array_set_1darray_complex8
     module procedure generic_array_set_1darray_bytes
     module procedure generic_array_set_1darray_unicode
     module procedure generic_array_set_ndarray_integer2
     module procedure generic_array_set_ndarray_integer4
     module procedure generic_array_set_ndarray_integer8
     module procedure generic_array_set_ndarray_unsigned1
     module procedure generic_array_set_ndarray_unsigned2
     module procedure generic_array_set_ndarray_unsigned4
     module procedure generic_array_set_ndarray_unsigned8
     module procedure generic_array_set_ndarray_real4
     module procedure generic_array_set_ndarray_real8
     module procedure generic_array_set_ndarray_complex4
     module procedure generic_array_set_ndarray_complex8
     module procedure generic_array_set_ndarray_character
     module procedure generic_array_set_ndarray_bytes
     module procedure generic_array_set_ndarray_unicode
  end interface generic_array_set
  interface generic_map_set
     module procedure generic_map_get_generic
     module procedure generic_map_set_boolean
     ! module procedure generic_map_set_integer
     module procedure generic_map_set_null
     ! module procedure generic_map_set_number
     module procedure generic_map_set_array
     module procedure generic_map_set_map
     module procedure generic_map_set_ply
     module procedure generic_map_set_obj
     module procedure generic_map_set_python_class
     ! module procedure generic_map_set_python_function
     module procedure generic_map_set_schema
     ! module procedure generic_map_set_any
     module procedure generic_map_set_integer2
     module procedure generic_map_set_integer4
     module procedure generic_map_set_integer8
     module procedure generic_map_set_unsigned1
     module procedure generic_map_set_unsigned2
     module procedure generic_map_set_unsigned4
     module procedure generic_map_set_unsigned8
     module procedure generic_map_set_real4
     module procedure generic_map_set_real8
     module procedure generic_map_set_complex4
     module procedure generic_map_set_complex8
     module procedure generic_map_set_bytes
     module procedure generic_map_set_unicode
     module procedure generic_map_set_1darray_integer2
     module procedure generic_map_set_1darray_integer4
     module procedure generic_map_set_1darray_integer8
     module procedure generic_map_set_1darray_unsigned1
     module procedure generic_map_set_1darray_unsigned2
     module procedure generic_map_set_1darray_unsigned4
     module procedure generic_map_set_1darray_unsigned8
     module procedure generic_map_set_1darray_real4
     module procedure generic_map_set_1darray_real8
     module procedure generic_map_set_1darray_complex4
     module procedure generic_map_set_1darray_complex8
     module procedure generic_map_set_1darray_bytes
     module procedure generic_map_set_1darray_unicode
     module procedure generic_map_set_ndarray_integer2
     module procedure generic_map_set_ndarray_integer4
     module procedure generic_map_set_ndarray_integer8
     module procedure generic_map_set_ndarray_unsigned1
     module procedure generic_map_set_ndarray_unsigned2
     module procedure generic_map_set_ndarray_unsigned4
     module procedure generic_map_set_ndarray_unsigned8
     module procedure generic_map_set_ndarray_real4
     module procedure generic_map_set_ndarray_real8
     module procedure generic_map_set_ndarray_complex4
     module procedure generic_map_set_ndarray_complex8
     module procedure generic_map_set_ndarray_character
     module procedure generic_map_set_ndarray_bytes
     module procedure generic_map_set_ndarray_unicode
  end interface generic_map_set
  interface generic_array_get
     module procedure generic_array_get_generic
     module procedure generic_array_get_boolean
     ! module procedure generic_array_get_integer
     module procedure generic_array_get_null
     ! module procedure generic_array_get_number
     module procedure generic_array_get_array
     module procedure generic_array_get_map
     module procedure generic_array_get_ply
     module procedure generic_array_get_obj
     module procedure generic_array_get_python_class
     ! module procedure generic_array_get_python_function
     module procedure generic_array_get_schema
     ! module procedure generic_array_get_any
     module procedure generic_array_get_integer2
     module procedure generic_array_get_integer4
     module procedure generic_array_get_integer8
     module procedure generic_array_get_unsigned1
     module procedure generic_array_get_unsigned2
     module procedure generic_array_get_unsigned4
     module procedure generic_array_get_unsigned8
     module procedure generic_array_get_real4
     module procedure generic_array_get_real8
     module procedure generic_array_get_complex4
     module procedure generic_array_get_complex8
     module procedure generic_array_get_bytes
     module procedure generic_array_get_unicode
     module procedure generic_array_get_1darray_integer2
     module procedure generic_array_get_1darray_integer4
     module procedure generic_array_get_1darray_integer8
     module procedure generic_array_get_1darray_unsigned1
     module procedure generic_array_get_1darray_unsigned2
     module procedure generic_array_get_1darray_unsigned4
     module procedure generic_array_get_1darray_unsigned8
     module procedure generic_array_get_1darray_real4
     module procedure generic_array_get_1darray_real8
     module procedure generic_array_get_1darray_complex4
     module procedure generic_array_get_1darray_complex8
     module procedure generic_array_get_1darray_bytes
     module procedure generic_array_get_1darray_unicode
     module procedure generic_array_get_ndarray_integer2
     module procedure generic_array_get_ndarray_integer4
     module procedure generic_array_get_ndarray_integer8
     module procedure generic_array_get_ndarray_unsigned1
     module procedure generic_array_get_ndarray_unsigned2
     module procedure generic_array_get_ndarray_unsigned4
     module procedure generic_array_get_ndarray_unsigned8
     module procedure generic_array_get_ndarray_real4
     module procedure generic_array_get_ndarray_real8
     module procedure generic_array_get_ndarray_complex4
     module procedure generic_array_get_ndarray_complex8
     module procedure generic_array_get_ndarray_character
     module procedure generic_array_get_ndarray_bytes
     module procedure generic_array_get_ndarray_unicode
  end interface generic_array_get
  interface generic_map_get
     module procedure generic_map_get_generic
     module procedure generic_map_get_boolean
     ! module procedure generic_map_get_integer
     module procedure generic_map_get_null
     ! module procedure generic_map_get_number
     module procedure generic_map_get_array
     module procedure generic_map_get_map
     module procedure generic_map_get_ply
     module procedure generic_map_get_obj
     module procedure generic_map_get_python_class
     ! module procedure generic_map_get_python_function
     module procedure generic_map_get_schema
     ! module procedure generic_map_get_any
     module procedure generic_map_get_integer2
     module procedure generic_map_get_integer4
     module procedure generic_map_get_integer8
     module procedure generic_map_get_unsigned1
     module procedure generic_map_get_unsigned2
     module procedure generic_map_get_unsigned4
     module procedure generic_map_get_unsigned8
     module procedure generic_map_get_real4
     module procedure generic_map_get_real8
     module procedure generic_map_get_complex4
     module procedure generic_map_get_complex8
     module procedure generic_map_get_bytes
     module procedure generic_map_get_unicode
     module procedure generic_map_get_1darray_integer2
     module procedure generic_map_get_1darray_integer4
     module procedure generic_map_get_1darray_integer8
     module procedure generic_map_get_1darray_unsigned1
     module procedure generic_map_get_1darray_unsigned2
     module procedure generic_map_get_1darray_unsigned4
     module procedure generic_map_get_1darray_unsigned8
     module procedure generic_map_get_1darray_real4
     module procedure generic_map_get_1darray_real8
     module procedure generic_map_get_1darray_complex4
     module procedure generic_map_get_1darray_complex8
     module procedure generic_map_get_1darray_bytes
     module procedure generic_map_get_1darray_unicode
     module procedure generic_map_get_ndarray_integer2
     module procedure generic_map_get_ndarray_integer4
     module procedure generic_map_get_ndarray_integer8
     module procedure generic_map_get_ndarray_unsigned1
     module procedure generic_map_get_ndarray_unsigned2
     module procedure generic_map_get_ndarray_unsigned4
     module procedure generic_map_get_ndarray_unsigned8
     module procedure generic_map_get_ndarray_real4
     module procedure generic_map_get_ndarray_real8
     module procedure generic_map_get_ndarray_complex4
     module procedure generic_map_get_ndarray_complex8
     module procedure generic_map_get_ndarray_character
     module procedure generic_map_get_ndarray_bytes
     module procedure generic_map_get_ndarray_unicode
  end interface generic_map_get
  interface yggassign
     module procedure yggassign_yggchar2character
     ! module procedure yggassign_character2yggchar
     module procedure yggassign_integer_1d_to_array
     module procedure yggassign_integer_1d_from_array
     module procedure yggassign_integer2_1d_to_array
     module procedure yggassign_integer2_1d_from_array
     module procedure yggassign_integer4_1d_to_array
     module procedure yggassign_integer4_1d_from_array
     module procedure yggassign_integer8_1d_to_array
     module procedure yggassign_integer8_1d_from_array
     ! module procedure yggassign_unsigned_1d_to_array
     ! module procedure yggassign_unsigned_1d_from_array
     module procedure yggassign_unsigned2_1d_to_array
     module procedure yggassign_unsigned2_1d_from_array
     module procedure yggassign_unsigned4_1d_to_array
     module procedure yggassign_unsigned4_1d_from_array
     module procedure yggassign_unsigned8_1d_to_array
     module procedure yggassign_unsigned8_1d_from_array
     module procedure yggassign_real_1d_to_array
     module procedure yggassign_real_1d_from_array
     module procedure yggassign_real4_1d_to_array
     module procedure yggassign_real4_1d_from_array
     module procedure yggassign_real8_1d_to_array
     module procedure yggassign_real8_1d_from_array
     module procedure yggassign_real16_1d_to_array
     module procedure yggassign_real16_1d_from_array
     module procedure yggassign_complex_1d_to_array
     module procedure yggassign_complex_1d_from_array
     module procedure yggassign_complex4_1d_to_array
     module procedure yggassign_complex4_1d_from_array
     module procedure yggassign_complex8_1d_to_array
     module procedure yggassign_complex8_1d_from_array
     module procedure yggassign_complex16_1d_to_array
     module procedure yggassign_complex16_1d_from_array
     module procedure yggassign_logical_1d_to_array
     module procedure yggassign_logical_1d_from_array
     module procedure yggassign_logical1_1d_to_array
     module procedure yggassign_logical1_1d_from_array
     module procedure yggassign_logical2_1d_to_array
     module procedure yggassign_logical2_1d_from_array
     module procedure yggassign_logical4_1d_to_array
     module procedure yggassign_logical4_1d_from_array
     module procedure yggassign_logical8_1d_to_array
     module procedure yggassign_logical8_1d_from_array
     ! TODO: ND array
  end interface yggassign
  interface yggarr
     module procedure ygggeneric2yggarr
  end interface yggarr
  interface yggmap
     module procedure ygggeneric2yggmap
  end interface yggmap
  interface yggschema
     module procedure ygggeneric2yggschema
  end interface yggschema
  interface yggpyinst
     module procedure ygggeneric2yggpyinst
  end interface yggpyinst
  interface ygggeneric
     module procedure yggarr2ygggeneric
     module procedure yggmap2ygggeneric
     module procedure yggschema2ygggeneric
     module procedure yggpyinst2ygggeneric
  end interface ygggeneric
  interface yggpyfunc
     module procedure yggpython2yggpyfunc
  end interface yggpyfunc
  interface yggpython
     module procedure yggpython2yggpython
     module procedure yggpyfunc2yggpython
  end interface yggpython
  interface ygg_send_var
     module procedure ygg_send_var_sing
     module procedure ygg_send_var_mult
  end interface ygg_send_var
  interface ygg_recv_var
     module procedure ygg_recv_var_sing
     module procedure ygg_recv_var_mult
  end interface ygg_recv_var
  interface ygg_recv_var_realloc
     module procedure ygg_recv_var_realloc_sing
     module procedure ygg_recv_var_realloc_mult
  end interface ygg_recv_var_realloc
  interface ygg_rpc_call
     module procedure ygg_rpc_call_1v1
     module procedure ygg_rpc_call_1vm
     module procedure ygg_rpc_call_mv1
     module procedure ygg_rpc_call_mult
  end interface ygg_rpc_call
  interface ygg_rpc_call_realloc
     module procedure ygg_rpc_call_realloc_1v1
     module procedure ygg_rpc_call_realloc_1vm
     module procedure ygg_rpc_call_realloc_mv1
     module procedure ygg_rpc_call_realloc_mult
  end interface ygg_rpc_call_realloc
  interface ygguint
     module procedure init_ygguint1
     module procedure init_ygguint2
     module procedure init_ygguint4
     module procedure init_ygguint8
  end interface ygguint
  type :: yggcomm
     type(c_ptr) :: comm
  end type yggcomm
  type :: yggdtype
     type(c_ptr) :: ptr
  end type yggdtype
  type :: yggchar_r
     character, dimension(:), pointer :: x => null()
  end type yggchar_r
  type :: c_long_1d
     integer(kind=c_long), dimension(:), pointer :: x => null()
  end type c_long_1d
  type :: unsigned1_1d
     integer(kind=1), dimension(:), pointer :: x => null()
  end type unsigned1_1d
  type :: unsigned2_1d
     integer(kind=2), dimension(:), pointer :: x => null()
  end type unsigned2_1d
  type :: unsigned4_1d
     integer(kind=4), dimension(:), pointer :: x => null()
  end type unsigned4_1d
  type :: unsigned8_1d
     integer(kind=8), dimension(:), pointer :: x => null()
  end type unsigned8_1d
  type :: integer_1d
     integer, dimension(:), pointer :: x => null()
  end type integer_1d
  type :: integer2_1d
     integer(kind=2), dimension(:), pointer :: x => null()
  end type integer2_1d
  type :: integer4_1d
     integer(kind=4), dimension(:), pointer :: x => null()
  end type integer4_1d
  type :: integer8_1d
     integer(kind=8), dimension(:), pointer :: x => null()
  end type integer8_1d
  type :: real_1d
     real, dimension(:), pointer :: x => null()
  end type real_1d
  type :: real4_1d
     real(kind=4), dimension(:), pointer :: x => null()
  end type real4_1d
  type :: real8_1d
     real(kind=8), dimension(:), pointer :: x => null()
  end type real8_1d
#ifdef _WIN32
  type :: real16_1d
     real(kind=8), dimension(:), pointer :: x => null()
  end type real16_1d
#else
  type :: real16_1d
     real(kind=16), dimension(:), pointer :: x => null()
  end type real16_1d
#endif
  type :: complex_1d
     complex, dimension(:), pointer :: x => null()
  end type complex_1d
  type :: complex4_1d
     complex(kind=4), dimension(:), pointer :: x => null()
  end type complex4_1d
  type :: complex8_1d
     complex(kind=8), dimension(:), pointer :: x => null()
  end type complex8_1d
#ifdef _WIN32
  type :: complex16_1d
     complex(kind=8), dimension(:), pointer :: x => null()
  end type complex16_1d
#else
  type :: complex16_1d
     complex(kind=16), dimension(:), pointer :: x => null()
  end type complex16_1d
#endif
  type :: logical_1d
     logical, dimension(:), pointer :: x => null()
  end type logical_1d
  type :: logical1_1d
     logical(kind=1), dimension(:), pointer :: x => null()
  end type logical1_1d
  type :: logical2_1d
     logical(kind=2), dimension(:), pointer :: x => null()
  end type logical2_1d
  type :: logical4_1d
     logical(kind=4), dimension(:), pointer :: x => null()
  end type logical4_1d
  type :: logical8_1d
     logical(kind=8), dimension(:), pointer :: x => null()
  end type logical8_1d
  type :: character_1d
     type(yggchar_r), dimension(:), pointer :: x => null()
  end type character_1d
  type :: unsigned1_nd
     integer(kind=1), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned1_nd
  type :: unsigned2_nd
     integer(kind=2), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned2_nd
  type :: unsigned4_nd
     integer(kind=4), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned4_nd
  type :: unsigned8_nd
     integer(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned8_nd
  type :: c_long_nd
     integer(kind=c_long), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type c_long_nd
  type :: integer_nd
     integer, dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer_nd
  type :: integer2_nd
     integer(kind=2), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer2_nd
  type :: integer4_nd
     integer(kind=4), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer4_nd
  type :: integer8_nd
     integer(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer8_nd
  type :: real_nd
     real, dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real_nd
  type :: real4_nd
     real(kind=4), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real4_nd
  type :: real8_nd
     real(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real8_nd
#ifdef _WIN32
  type :: real16_nd
     real(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real16_nd
#else
  type :: real16_nd
     real(kind=16), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real16_nd
#endif
  type :: complex_nd
     complex, dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex_nd
  type :: complex4_nd
     complex(kind=4), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex4_nd
  type :: complex8_nd
     complex(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex8_nd
#ifdef _WIN32
  type :: complex16_nd
     complex(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex16_nd
#else
  type :: complex16_nd
     complex(kind=16), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex16_nd
#endif
  type :: logical_nd
     logical, dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical_nd
  type :: logical1_nd
     logical(kind=1), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical1_nd
  type :: logical2_nd
     logical(kind=2), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical2_nd
  type :: logical4_nd
     logical(kind=4), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical4_nd
  type :: logical8_nd
     logical(kind=8), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical8_nd
  type :: bytes_nd
     character(len=:), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type bytes_nd
  type :: unicode_nd
     character(kind=ucs4, len=:), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unicode_nd
  type :: character_nd
     type(yggchar_r), dimension(:), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type character_nd
  type :: unsigned1_2d
     integer(kind=1), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned1_2d
  type :: unsigned2_2d
     integer(kind=2), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned2_2d
  type :: unsigned4_2d
     integer(kind=4), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned4_2d
  type :: unsigned8_2d
     integer(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type unsigned8_2d
  type :: c_long_2d
     integer(kind=c_long), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type c_long_2d
  type :: integer_2d
     integer, dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer_2d
  type :: integer2_2d
     integer(kind=2), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer2_2d
  type :: integer4_2d
     integer(kind=4), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer4_2d
  type :: integer8_2d
     integer(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type integer8_2d
  type :: real_2d
     real, dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real_2d
  type :: real4_2d
     real(kind=4), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real4_2d
  type :: real8_2d
     real(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real8_2d
#ifdef _WIN32
  type :: real16_2d
     real(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real16_2d
#else
  type :: real16_2d
     real(kind=16), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type real16_2d
#endif
  type :: complex_2d
     complex, dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex_2d
  type :: complex4_2d
     complex(kind=4), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex4_2d
  type :: complex8_2d
     complex(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex8_2d
#ifdef _WIN32
  type :: complex16_2d
     complex(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex16_2d
#else
  type :: complex16_2d
     complex(kind=16), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type complex16_2d
#endif
  type :: logical_2d
     logical, dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical_2d
  type :: logical1_2d
     logical(kind=1), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical1_2d
  type :: logical2_2d
     logical(kind=2), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical2_2d
  type :: logical4_2d
     logical(kind=4), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical4_2d
  type :: logical8_2d
     logical(kind=8), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type logical8_2d
  type :: character_2d
     type(yggchar_r), dimension(:, :), pointer :: x => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape => null()
  end type character_2d
  type :: yggptr
     character(len=15) :: type = "none"
     logical :: ndarray = .false.
     logical :: array = .false.
     logical :: alloc = .false.
     integer(kind=8) :: len = 0
     integer(kind=8) :: prec = 0
     integer(kind=8) :: ndim = 0
     integer(kind=8) :: nbytes = 0
     integer(kind=8), dimension(:), pointer :: shape => null()
     type(c_ptr) :: ptr = c_null_ptr
     class(*), pointer :: item => null()
     class(*), dimension(:), pointer :: item_array => null()
     class(*), dimension(:, :), pointer :: item_array_2d => null()
     class(*), dimension(:, :, :), pointer :: item_array_3d => null()
     character, dimension(:), pointer :: data_character_unit => null()
     character(kind=ucs4), dimension(:), &
          pointer :: data_unicode_unit => null()
     integer(kind=c_size_t), pointer :: len_c => null()
     integer(kind=c_size_t), pointer :: prec_c => null()
     integer(kind=c_size_t), pointer :: ndim_c => null()
     integer(kind=c_size_t), dimension(:), pointer :: shape_c => null()
     type(c_ptr) :: len_ptr = c_null_ptr
     type(c_ptr) :: prec_ptr = c_null_ptr
     type(c_ptr) :: ndim_ptr = c_null_ptr
     type(c_ptr) :: shape_ptr = c_null_ptr
  end type yggptr
  type :: yggptr_arr
     type(yggptr), dimension(:), pointer :: vals => null()
  end type yggptr_arr
  type :: yggptr_map
     character(len=20), dimension(:), pointer :: keys => null()
     type(yggptr), dimension(:), pointer :: vals => null()
  end type yggptr_map
  type, bind(c) :: ygggeneric
     character(kind=c_char) :: prefix
     type(c_ptr) :: obj
  end type ygggeneric
  type :: yggnull
     type(c_ptr) :: ptr = c_null_ptr
   ! contains
   !   procedure :: write_null
   !   generic :: write(formatted) => write_null
  end type yggnull
  type, bind(c) :: yggarr
     character(kind=c_char) :: prefix
     type(c_ptr) :: obj
  end type yggarr
  type, bind(c) :: yggmap
     character(kind=c_char) :: prefix
     type(c_ptr) :: obj
  end type yggmap
  type, bind(c) :: yggschema
     character(kind=c_char) :: prefix
     type(c_ptr) :: obj
  end type yggschema
  type, bind(c) :: yggpyinst
     character(kind=c_char) :: prefix
     type(c_ptr) :: obj
  end type yggpyinst
  type, bind(c) :: yggpyfunc
     character(kind=c_char), dimension(1000) :: name = c_null_char
     type(c_ptr) :: args = c_null_ptr
     type(c_ptr) :: kwargs = c_null_ptr
     type(c_ptr) :: obj = c_null_ptr
  end type yggpyfunc
  type, bind(c) :: yggpython
     character(kind=c_char), dimension(1000) :: name = c_null_char
     type(c_ptr) :: args = c_null_ptr
     type(c_ptr) :: kwargs = c_null_ptr
     type(c_ptr) :: obj = c_null_ptr
  end type yggpython
  type, bind(c) :: yggply
     character(kind=c_char), dimension(100) :: material
     integer(kind=c_int) :: nvert
     integer(kind=c_int) :: nface
     integer(kind=c_int) :: nedge
     type(c_ptr) :: c_vertices
     type(c_ptr) :: c_faces
     type(c_ptr) :: c_edges
     type(c_ptr) :: c_vertex_colors
     type(c_ptr) :: c_edge_colors
     type(c_ptr) :: c_nvert_in_face
  end type yggply
  type, bind(c) :: yggobj
     character(kind=c_char), dimension(100) :: material
     integer(kind=c_int) :: nvert
     integer(kind=c_int) :: ntexc
     integer(kind=c_int) :: nnorm
     integer(kind=c_int) :: nparam
     integer(kind=c_int) :: npoint
     integer(kind=c_int) :: nline
     integer(kind=c_int) :: nface
     integer(kind=c_int) :: ncurve
     integer(kind=c_int) :: ncurve2
     integer(kind=c_int) :: nsurf
     type(c_ptr) :: c_vertices
     type(c_ptr) :: c_vertex_colors
     type(c_ptr) :: c_texcoords
     type(c_ptr) :: c_normals
     type(c_ptr) :: c_params
     type(c_ptr) :: c_points
     type(c_ptr) :: c_nvert_in_point
     type(c_ptr) :: c_lines
     type(c_ptr) :: c_nvert_in_line
     type(c_ptr) :: c_line_texcoords
     type(c_ptr) :: c_faces
     type(c_ptr) :: c_nvert_in_face
     type(c_ptr) :: c_face_texcoords
     type(c_ptr) :: c_face_normals
     type(c_ptr) :: c_curves
     type(c_ptr) :: c_curve_params
     type(c_ptr) :: c_nvert_in_curve
     type(c_ptr) :: c_curves2
     type(c_ptr) :: c_nparam_in_curve2
     type(c_ptr) :: c_surfaces
     type(c_ptr) :: c_nvert_in_surface
     type(c_ptr) :: c_surface_params_u
     type(c_ptr) :: c_surface_params_v
     type(c_ptr) :: c_surface_texcoords
     type(c_ptr) :: c_surface_normals
  end type yggobj
  type ygguint1
     integer(kind=1) :: x
  end type ygguint1
  type ygguint2
     integer(kind=2) :: x
  end type ygguint2
  type ygguint4
     integer(kind=4) :: x
  end type ygguint4
  type ygguint8
     integer(kind=8) :: x
  end type ygguint8

  interface assignment(=)
     module procedure ygguint1_assign
     module procedure ygguint2_assign
     module procedure ygguint4_assign
     module procedure ygguint8_assign
  end interface assignment(=)

  public :: yggarg, yggchar_r, yggcomm, ygggeneric, &
       yggptr, yggnull, yggarr, yggmap, &
       yggschema, yggpython, yggply, yggobj, yggpyinst, yggpyfunc, &
       LINE_SIZE_MAX

  include "YggInterface_cdef.f90"

#define WITH_GLOBAL_SCOPE(COMM) call set_global_comm(); COMM; call unset_global_comm()

contains

  ! include "YggInterface_copy.f90"
  include "YggInterface_realloc.f90"
  include "YggInterface_c2f.f90"
  include "YggInterface_arg.f90"
  include "YggInterface_conv.f90"
  include "YggInterface_assign.f90"
  include "YggInterface_array.f90"
  include "YggInterface_map.f90"

  subroutine ygguint1_assign(self, other)
    type(ygguint1), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=1)
  end subroutine ygguint1_assign
  subroutine ygguint2_assign(self, other)
    type(ygguint2), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=2)
  end subroutine ygguint2_assign
  subroutine ygguint4_assign(self, other)
    type(ygguint4), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=4)
  end subroutine ygguint4_assign
  subroutine ygguint8_assign(self, other)
    type(ygguint8), intent(inout) :: self
    integer, intent(in) :: other
    self%x = int(other, kind=8)
  end subroutine ygguint8_assign


#ifndef _WIN32
  function yggarg_scalar_real16(x) result (y)
    type(yggptr) :: y
    real(kind=16), target :: x
    real(kind=16), pointer :: xp
    y = yggarg_scalar_init(x)
    xp => x
    y%type = "real"
    y%ptr = c_loc(xp)
    y%nbytes = 16
  end function yggarg_scalar_real16
  function yggarg_scalar_complex16(x) result (y)
    type(yggptr) :: y
    complex(kind=16), target :: x
    complex(kind=16), pointer :: xp
    y = yggarg_scalar_init(x)
    xp => x
    y%type = "complex"
    y%ptr = c_loc(xp)
    y%nbytes = 16 * 2
  end function yggarg_scalar_complex16
  function yggarg_1darray_real16(x, x_shape) result (y)
    real(kind=16), dimension(:), target :: x
    real(kind=16), dimension(:), pointer :: xp
    integer, dimension(:), optional :: x_shape
    type(yggptr) :: y
    xp => x
    if (present(x_shape)) then
       y = yggarg_ndarray_init(x, x_shape)
    else
       y = yggarg_ndarray_init(x)
    end if
    y%type = "real"
    y%ptr = c_loc(xp(1))
  end function yggarg_1darray_real16
  function yggarg_1darray_complex16(x, x_shape) result (y)
    complex(kind=16), dimension(:), target :: x
    complex(kind=16), dimension(:), pointer :: xp
    integer, dimension(:), optional :: x_shape
    type(yggptr) :: y
    xp => x
    if (present(x_shape)) then
       y = yggarg_ndarray_init(x, x_shape)
    else
       y = yggarg_ndarray_init(x)
    end if
    y%type = "complex"
    y%ptr = c_loc(xp(1))
  end function yggarg_1darray_complex16
  function yggarg_2darray_real16(x) result (y)
    real(kind=16), dimension(:, :), target :: x
    real(kind=16), dimension(:), pointer :: xp
    type(yggptr) :: y
    allocate(xp(size(x)))
    xp = reshape(x, [size(x)])
    y = yggarg(xp, shape(x))
    call yggarg_2darray_init(y, x)
  end function yggarg_2darray_real16
  function yggarg_2darray_complex16(x) result (y)
    complex(kind=16), dimension(:, :), target :: x
    complex(kind=16), dimension(:), pointer :: xp
    type(yggptr) :: y
    allocate(xp(size(x)))
    xp = reshape(x, [size(x)])
    y = yggarg(xp, shape(x))
    call yggarg_2darray_init(y, x)
  end function yggarg_2darray_complex16
#endif
  
  ! Utilities
  function init_ygguint1(x) result(y)
    integer(kind=1) :: x
    type(ygguint1) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint1
  function init_ygguint2(x) result(y)
    integer(kind=2) :: x
    type(ygguint2) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint2
  function init_ygguint4(x) result(y)
    integer(kind=4) :: x
    type(ygguint4) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint4
  function init_ygguint8(x) result(y)
    integer(kind=8) :: x
    type(ygguint8) :: y
    y%x = x
    if (y%x.lt.0) stop "Unsigned int cannot be less than 0."
  end function init_ygguint8
  subroutine display_null(x)
    class(yggnull), intent(in) :: x
    write (*, '("NULL")')
  end subroutine display_null
  ! subroutine write_null(dtv, unit, iotype, v_list, iostat, iomsg)
  !   ! Argument names here from the std, but you can name them differently.
  !   class(yggnull), intent(in) :: dtv   ! Object to write.
  !   integer, intent(in) :: unit         ! Internal unit to write to.
  !   character(*), intent(in) :: iotype  ! LISTDIRECTED or DTxxx
  !   integer, intent(in) :: v_list(:)    ! parameters from fmt spec.
  !   integer, intent(out) :: iostat      ! non zero on error, etc.
  !   character(*), intent(inout) :: iomsg  ! define if iostat non zero.
  !   write (unit, '("NULL")', IOSTAT=iostat, IOMSG=iomsg)
  ! end subroutine write_null
  subroutine fix_format_str(x)
    implicit none
    character(len=*) :: x
    integer :: i, length
    length = len(x)
    i = index(x, "\t")
    do while (i.ne.0)
       x(i:i) = char(9)
       x((i+1):length) = x((i+2):length)
       length = len(x)
       i = index(x, "\t")
    end do
    i = index(x, "\n")
    do while (i.ne.0)
       x(i:i) = NEW_LINE('c')
       x((i+1):length) = x((i+2):length)
       length = len(x)
       i = index(x, "\n")
    end do
  end subroutine fix_format_str

  ! YggInterface

  ! Utilities
  subroutine ygglog_info(fmt)
    implicit none
    character(len=*), intent(in) :: fmt
    character(len=len_trim(fmt)+1) :: c_fmt
    c_fmt = trim(fmt)//c_null_char
    call ygglog_info_c(c_fmt)
  end subroutine ygglog_info
  subroutine ygglog_debug(fmt)
    implicit none
    character(len=*), intent(in) :: fmt
    character(len=len_trim(fmt)+1) :: c_fmt
    c_fmt = trim(fmt)//c_null_char
    call ygglog_debug_c(c_fmt)
  end subroutine ygglog_debug
  subroutine ygglog_error(fmt)
    implicit none
    character(len=*), intent(in) :: fmt
    character(len=len_trim(fmt)+1) :: c_fmt
    c_fmt = trim(fmt)//c_null_char
    call ygglog_error_c(c_fmt)
  end subroutine ygglog_error

  ! Methods for initializing channels
  function is_comm_format_array_type(x, args) result(out)
    implicit none
    type(yggcomm), intent(in) :: x
    type(yggptr) :: args(:)
    logical :: out
    integer(c_int) :: c_out
    integer :: i
    c_out = is_comm_format_array_type_c(x%comm)
    if (c_out.eq.0) then
       out = .false.
    else if (c_out.eq.1) then
       out = .true.
    else if (size(args).eq.1) then
       out = .false.
    else
       out = .true.
       do i = 2, size(args)
          if (.not.args(i)%array) then
             out = .false.
             exit
          end if
       end do
       if ((out).and.(.not.((args(1)%array).or.(is_size_t(args(1)))))) then
          out = .false.
       end if
       ! stop "is_comm_format_array_type: Error checking type."
    end if
  end function is_comm_format_array_type
  
  function ygg_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_output_c(c_name)
  end function ygg_output
  
  function ygg_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_input_c(c_name)
  end function ygg_input

  function ygg_output_type(name, datatype) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype) :: datatype
    character(len=len_trim(name)+1) :: c_name
    type(c_ptr) :: c_datatype
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_datatype = datatype%ptr
    channel%comm = ygg_output_type_c(c_name, c_datatype)
  end function ygg_output_type
  
  function ygg_input_type(name, datatype) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype) :: datatype
    character(len=len_trim(name)+1) :: c_name
    type(c_ptr) :: c_datatype
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_datatype = datatype%ptr
    channel%comm = ygg_input_type_c(c_name, c_datatype)
  end function ygg_input_type
  
  function ygg_output_fmt(name, fmt) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(fmt)+1) :: c_fmt
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_fmt = trim(fmt)//c_null_char
    call fix_format_str(c_fmt)
    channel%comm = ygg_output_fmt_c(c_name, c_fmt)
  end function ygg_output_fmt
  
  function ygg_input_fmt(name, fmt) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(fmt)+1) :: c_fmt
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_fmt = trim(fmt)//c_null_char
    call fix_format_str(c_fmt)
    channel%comm = ygg_input_fmt_c(c_name, c_fmt)
  end function ygg_input_fmt
  
  function ygg_ascii_file_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_file_output_c(c_name)
  end function ygg_ascii_file_output
  
  function ygg_ascii_file_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_file_input_c(c_name)
  end function ygg_ascii_file_input
  
  function ygg_ascii_table_output(name, format_str) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: format_str
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(format_str)+1) :: c_format_str
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_format_str = trim(format_str)//c_null_char
    call fix_format_str(c_format_str)
    channel%comm = ygg_ascii_table_output_c(c_name, c_format_str)
  end function ygg_ascii_table_output
  
  function ygg_ascii_table_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_table_input_c(c_name)
  end function ygg_ascii_table_input
  
  function ygg_ascii_array_output(name, format_str) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: format_str
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(format_str)+1) :: c_format_str
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_format_str = trim(format_str)//c_null_char
    call fix_format_str(c_format_str)
    channel%comm = ygg_ascii_array_output_c(c_name, c_format_str)
  end function ygg_ascii_array_output
  
  function ygg_ascii_array_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ascii_array_input_c(c_name)
  end function ygg_ascii_array_input
  
  function ygg_ply_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ply_output_c(c_name)
  end function ygg_ply_output
  
  function ygg_ply_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_ply_input_c(c_name)
  end function ygg_ply_input
  
  function ygg_obj_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_obj_output_c(c_name)
  end function ygg_obj_output
  
  function ygg_obj_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_obj_input_c(c_name)
  end function ygg_obj_input

  function ygg_generic_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_generic_output_c(c_name)
  end function ygg_generic_output
  
  function ygg_generic_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_generic_input_c(c_name)
  end function ygg_generic_input

  function ygg_any_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_any_output_c(c_name)
  end function ygg_any_output
  
  function ygg_any_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_any_input_c(c_name)
  end function ygg_any_input

  function ygg_json_array_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_array_output_c(c_name)
  end function ygg_json_array_output
  
  function ygg_json_array_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_array_input_c(c_name)
  end function ygg_json_array_input

  function ygg_json_object_output(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_object_output_c(c_name)
  end function ygg_json_object_output
  
  function ygg_json_object_input(name) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    channel%comm = ygg_json_object_input_c(c_name)
  end function ygg_json_object_input

  function ygg_rpc_client(name, out_fmt_in, in_fmt_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: out_fmt_in
    character(len=*), intent(in), optional :: in_fmt_in
    character(len=:), allocatable :: out_fmt
    character(len=:), allocatable :: in_fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=:), allocatable :: c_out_fmt
    character(len=:), allocatable :: c_in_fmt
    type(yggcomm) :: channel
    if (present(out_fmt_in)) then
       out_fmt = out_fmt_in
    else
       out_fmt = "%s"
    end if
    if (present(in_fmt_in)) then
       in_fmt = in_fmt_in
    else
       in_fmt = "%s"
    end if
    allocate(character(len=len_trim(in_fmt)+1) :: c_in_fmt)
    allocate(character(len=len_trim(out_fmt)+1) :: c_out_fmt)
    c_name = trim(name)//c_null_char
    c_out_fmt = trim(out_fmt)//c_null_char
    c_in_fmt = trim(in_fmt)//c_null_char
    call fix_format_str(c_out_fmt)
    call fix_format_str(c_in_fmt)
    channel%comm = ygg_rpc_client_c(c_name, c_out_fmt, c_in_fmt)
  end function ygg_rpc_client

  function ygg_rpc_server(name, in_fmt_in, out_fmt_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in), optional :: in_fmt_in
    character(len=*), intent(in), optional :: out_fmt_in
    character(len=:), allocatable :: in_fmt
    character(len=:), allocatable :: out_fmt
    character(len=len_trim(name)+1) :: c_name
    character(len=:), allocatable :: c_in_fmt
    character(len=:), allocatable :: c_out_fmt
    type(yggcomm) :: channel
    if (present(in_fmt_in)) then
       in_fmt = in_fmt_in
    else
       in_fmt = "%s"
    end if
    if (present(out_fmt_in)) then
       out_fmt = out_fmt_in
    else
       out_fmt = "%s"
    end if
    allocate(character(len=len_trim(in_fmt)+1) :: c_in_fmt)
    allocate(character(len=len_trim(out_fmt)+1) :: c_out_fmt)
    c_name = trim(name)//c_null_char
    c_in_fmt = trim(in_fmt)//c_null_char
    c_out_fmt = trim(out_fmt)//c_null_char
    call fix_format_str(c_in_fmt)
    call fix_format_str(c_out_fmt)
    channel%comm = ygg_rpc_server_c(c_name, c_in_fmt, c_out_fmt)
  end function ygg_rpc_server

  function ygg_rpc_client_type(name, out_type_in, in_type_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype), optional :: out_type_in
    type(yggdtype), optional :: in_type_in
    type(c_ptr) :: c_out_type
    type(c_ptr) :: c_in_type
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    if (present(out_type_in)) then
       c_out_type = out_type_in%ptr
    else
       c_out_type = c_null_ptr
    end if
    if (present(in_type_in)) then
       c_in_type = in_type_in%ptr
    else
       c_in_type = c_null_ptr
    end if
    c_name = trim(name)//c_null_char
    channel%comm = ygg_rpc_client_type_c(c_name, c_out_type, c_in_type)
  end function ygg_rpc_client_type

  function ygg_rpc_server_type(name, in_type_in, out_type_in) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    type(yggdtype), optional :: in_type_in
    type(yggdtype), optional :: out_type_in
    type(c_ptr) :: c_in_type
    type(c_ptr) :: c_out_type
    character(len=len_trim(name)+1) :: c_name
    type(yggcomm) :: channel
    if (present(in_type_in)) then
       c_in_type = in_type_in%ptr
    else
       c_in_type = c_null_ptr
    end if
    if (present(out_type_in)) then
       c_out_type = out_type_in%ptr
    else
       c_out_type = c_null_ptr
    end if
    c_name = trim(name)//c_null_char
    channel%comm = ygg_rpc_server_type_c(c_name, c_in_type, c_out_type)
  end function ygg_rpc_server_type

  function ygg_timesync(name, units) result(channel)
    implicit none
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: units
    character(len=len_trim(name)+1) :: c_name
    character(len=len_trim(units)+1) :: c_units
    type(yggcomm) :: channel
    c_name = trim(name)//c_null_char
    c_units = trim(units)//c_null_char
    channel%comm = ygg_timesync_c(c_name, c_units)
  end function ygg_timesync

  ! Method for constructing data types
  function is_dtype_format_array(type_struct) result(out)
    implicit none
    type(yggdtype) :: type_struct
    logical :: out
    integer(kind=c_int) :: c_out
    c_out = is_dtype_format_array_c(type_struct%ptr)
    if (c_out.eq.0) then
       out = .false.
    else if (c_out.eq.1) then
       out = .true.
    else
       stop "is_dtype_format_array: Error checking data type"
    end if
  end function is_dtype_format_array
  
  function create_dtype_empty(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_empty_c(logical(use_generic, kind=1))
  end function create_dtype_empty

  function create_dtype_python(pyobj, use_generic) result(out)
    implicit none
    type(c_ptr) :: pyobj
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_python_c(pyobj, logical(use_generic, kind=1))
  end function create_dtype_python

  function create_dtype_direct(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_direct_c(logical(use_generic, kind=1))
  end function create_dtype_direct

  function create_dtype_default(typename, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: typename
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    out%ptr = create_dtype_default_c(c_typename, logical(use_generic, kind=1))
  end function create_dtype_default

  function create_dtype_scalar(subtype, precision, units, &
       use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    character(len=*), intent(in) :: units
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    integer(kind=c_size_t) :: c_precision
    character(len=len_trim(units)+1) :: c_units
    c_subtype = trim(subtype)//c_null_char
    c_precision = precision
    c_units = trim(units)//c_null_char
    out%ptr = create_dtype_scalar_c(c_subtype, c_precision, c_units, &
         logical(use_generic, kind=1))
  end function create_dtype_scalar

  function create_dtype_1darray(subtype, precision, length, &
       units, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: length
    character(len=*), intent(in) :: units
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    integer(kind=c_size_t) :: c_precision
    integer(kind=c_size_t) :: c_length
    character(len=len_trim(units)+1) :: c_units
    c_subtype = trim(subtype)//c_null_char
    c_precision = precision
    c_length = length
    c_units = trim(units)//c_null_char
    out%ptr = create_dtype_1darray_c(c_subtype, c_precision, c_length, &
         c_units, logical(use_generic, kind=1))
  end function create_dtype_1darray

  function create_dtype_ndarray(subtype, precision, ndim, &
       shape, units, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: ndim
    integer(kind=c_size_t), dimension(:), target, intent(in) :: shape
    character(len=*), intent(in) :: units
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    integer(kind=c_size_t), dimension(:), pointer :: pshape
    character(len=len_trim(subtype)+1) :: c_subtype
    integer(kind=c_size_t) :: c_precision
    integer(kind=c_size_t) :: c_ndim
    type(c_ptr) :: c_shape
    character(len=len_trim(units)+1) :: c_units
    pshape => shape
    c_subtype = trim(subtype)//c_null_char
    c_precision = precision
    c_ndim = ndim
    c_shape = c_loc(shape(1))
    c_units = trim(units)//c_null_char
    out%ptr = create_dtype_ndarray_c(c_subtype, c_precision, c_ndim, &
         c_shape, c_units, logical(use_generic, kind=1))
  end function create_dtype_ndarray

  function create_dtype_json_array(nitems, items, use_generic) &
       result(out)
    implicit none
    integer, intent(in) :: nitems
    type(yggdtype), dimension(:), intent(in) :: items
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    integer(kind=c_size_t) :: c_nitems
    type(c_ptr), target :: c_items(size(items))
    integer :: i
    c_nitems = nitems
    do i = 1, size(items)
       c_items(i) = items(i)%ptr
    end do
    out%ptr = create_dtype_json_array_c(c_nitems, c_loc(c_items(1)), &
         logical(use_generic, kind=1))
  end function create_dtype_json_array

  function create_dtype_json_object(nitems, keys, values, use_generic) &
       result(out)
    implicit none
    integer, intent(in) :: nitems
    character(len=*), dimension(:), intent(in), target :: keys
    type(yggdtype), dimension(:), intent(in) :: values
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    integer(kind=c_size_t) :: c_nitems
    type(c_ptr), target :: c_keys(size(keys))
    type(c_ptr), target :: c_values(size(values))
    character(kind=c_char, len=len(keys(1))), pointer :: ikey
    integer :: i, ikey_len
    c_nitems = nitems
    do i = 1, size(keys)
       ikey => keys(i)
       ikey_len = len_trim(ikey)
       if (ikey_len.lt.len(ikey)) then
          ikey((ikey_len+1):(ikey_len+1)) = c_null_char
       end if
       c_keys(i) = c_loc(ikey(1:1))
    end do
    do i = 1, size(values)
       c_values(i) = values(i)%ptr
    end do
    out%ptr = create_dtype_json_object_c(c_nitems, c_loc(c_keys(1)), &
         c_loc(c_values(1)), logical(use_generic, kind=1))
  end function create_dtype_json_object

  function create_dtype_ply(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_ply_c(logical(use_generic, kind=1))
  end function create_dtype_ply

  function create_dtype_obj(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_obj_c(logical(use_generic, kind=1))
  end function create_dtype_obj

  function create_dtype_format(format_str, as_array, use_generic) &
       result(out)
    implicit none
    character(len=*), intent(in) :: format_str
    integer, intent(in) :: as_array
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(format_str)+1) :: c_format_str
    c_format_str = trim(format_str)//c_null_char
    call fix_format_str(c_format_str)
    out%ptr = create_dtype_format_c(c_format_str, as_array, logical(use_generic, kind=1))
  end function create_dtype_format

  function create_dtype_pyobj(typename, use_generic) result(out)
    implicit none
    character(len=*), intent(in) :: typename
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    out%ptr = create_dtype_pyobj_c(c_typename, logical(use_generic, kind=1))
  end function create_dtype_pyobj

  function create_dtype_schema(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_schema_c(logical(use_generic, kind=1))
  end function create_dtype_schema

  function create_dtype_any(use_generic) result(out)
    implicit none
    logical, intent(in) :: use_generic
    type(yggdtype) :: out
    out%ptr = create_dtype_any_c(logical(use_generic, kind=1))
  end function create_dtype_any

  ! Methods for sending/receiving
  function ygg_send(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(c_ptr) :: c_ygg_q
    character(len=*), intent(in) :: data
    character(len=len(data)+1) :: c_data
    integer, intent(in) :: data_len
    integer(kind=c_int) :: c_data_len
    logical :: flag
    integer(kind=c_int) :: c_flag
    c_ygg_q = ygg_q%comm
    c_data = data//c_null_char
    c_data_len = data_len
    c_flag = ygg_send_c(c_ygg_q, c_data, c_data_len)
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
  end function ygg_send
  
  function ygg_recv(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    character(len=*) :: data
    character(len=len(data)+1) :: c_data
    integer :: data_len
    integer(kind=c_int) :: c_data_len
    logical :: flag
    integer(kind=c_int) :: c_flag
    c_ygg_q = ygg_q%comm
    c_data = data//c_null_char
    c_data_len = data_len
    c_flag = ygg_recv_c(c_ygg_q, c_data, c_data_len)
    if (c_flag.ge.0) then
       flag = .true.
       data = c_data(:c_flag)
       data_len = c_flag
    else
       flag = .false.
    end if
  end function ygg_recv

  function ygg_send_nolimit(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(yggchar_r) :: data
    integer, intent(in) :: data_len
    logical :: flag
    integer(kind=c_size_t) :: len_used
    len_used = data_len
    flag = ygg_send_var(ygg_q, [yggarg(data), yggarg(len_used)])
  end function ygg_send_nolimit
  
  function ygg_recv_nolimit(ygg_q, data, data_len) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggchar_r) :: data
    integer :: data_len
    logical :: flag
    integer(kind=c_size_t) :: len_used
    len_used = data_len
    flag = ygg_recv_var_realloc(ygg_q, [yggarg(data), yggarg(len_used)])
    if (flag) then
       data_len = int(len_used)
    end if
  end function ygg_recv_nolimit

  function ygg_send_var_sing(ygg_q, arg) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(yggptr) :: arg
    logical :: flag
    flag = ygg_send_var_mult(ygg_q, [arg])
  end function ygg_send_var_sing
  function ygg_send_var_mult(ygg_q, args) result (flag)
    implicit none
    type(yggcomm), intent(in) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    integer :: c_nargs
    logical :: flag, is_format
    integer(kind=c_int) :: c_flag
    is_format = is_comm_format_array_type(ygg_q, args)
    c_ygg_q = ygg_q%comm
    c_nargs = pre_send(args, c_args, is_format)
    c_flag = ygg_send_var_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
    call post_send(args, c_args, flag)
  end function ygg_send_var_mult

  function is_next_size_t(args, i, req_array) result(flag)
    implicit none
    type(yggptr) :: args(:)
    integer :: i
    logical, intent(in), optional :: req_array
    logical :: flag
    if (i.ge.size(args)) then
       flag = .false.
    else
       if (present(req_array)) then
          flag = is_size_t(args(i+1), req_array)
       else
          flag = is_size_t(args(i+1))
       end if
    end if
  end function is_next_size_t

  function is_size_t(arg, req_array_in) result(flag)
    type(yggptr), intent(in) :: arg
    logical, optional :: req_array_in
    logical :: req_array
    logical :: flag
    if (present(req_array_in)) then
       req_array = req_array_in
    else
       req_array = .false.
    end if
    if (((arg%type.eq."integer").or.(arg%type.eq."size_t")).and. &
         (arg%nbytes.eq.8)) then
       flag = .true.
       if (req_array.and.(.not.arg%array)) then
          flag = .false.
       else if ((.not.req_array).and.arg%array) then
          flag = .false.
       end if
    else
       flag = .false.
    end if
  end function is_size_t

  function pre_send(args, c_args, is_format) result(c_nargs)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: is_format
    integer(kind=c_int) :: c_nargs
    integer(kind=c_size_t) :: k
    integer :: i, j
    integer :: nargs
    call ygglog_debug("pre_send: begin")
    nargs = size(args)  ! Number of arguments passed
    c_nargs = nargs  ! Number of arguments that C should be aware of
    if (is_format) then
       if (.not.is_size_t(args(1))) then
          nargs = nargs + 1
          c_nargs = c_nargs + 1
       end if
    end if
    do i = 1, size(args)
       allocate(args(i)%len_c)
       allocate(args(i)%prec_c)
       allocate(args(i)%ndim_c)
       allocate(args(i)%shape_c(args(i)%ndim))
       args(i)%len_c = 1
       args(i)%prec_c = 1
       args(i)%ndim_c = 1
       do k = 1, args(i)%ndim
          args(i)%shape_c(k) = args(i)%shape(k)
       end do
       if (args(i)%array) then
          if (args(i)%ndim.gt.1) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                ! Do nothing, vars already exist
             else if (is_next_size_t(args, i, req_array=.true.)) then
                if (args(i)%alloc) then
                   nargs = nargs + 1  ! For ndim
                   c_nargs = c_nargs + 1
                end if
             else if (args(i)%alloc) then
                nargs = nargs + 2  ! For ndim and shape
                c_nargs = c_nargs + 2
             end if
          else
             if ((.not.is_format).and.(.not.is_next_size_t(args, i))) then
                if (args(i)%alloc) then
                   nargs = nargs + 1  ! For the array size
                   c_nargs = c_nargs + 1
                end if
             end if
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (.not.is_next_size_t(args, i)) then
             nargs = nargs + 1  ! For the string size
             c_nargs = c_nargs + 1
          end if
       end if
    end do
    call ygglog_debug("pre_send: counted variables")
    allocate(c_args(nargs))
    j = 1
    if (is_format) then
       if (.not.is_size_t(args(1))) then
          args(1)%len_c = args(1)%len
          args(1)%len_ptr = c_loc(args(1)%len_c)
          c_args(j) = args(1)%len_ptr
          j = j + 1
       end if
    end if
    do i = 1, size(args)
       c_args(j) = args(i)%ptr
       j = j + 1
       if (args(i)%array) then
          if (args(i)%ndim.gt.1) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                args(i)%ndim_ptr = args(i+1)%ptr
                args(i)%shape_ptr = args(i+2)%ptr
             else if (is_next_size_t(args, i, req_array=.true.)) then
                args(i)%shape_ptr = args(i+1)%ptr
                if (args(i)%alloc) then
                   args(i)%ndim_c = args(i)%ndim
                   args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                   c_args(j) = args(i)%ndim_ptr
                   j = j + 1
                end if
             else if (args(i)%alloc) then
                args(i)%ndim_c = args(i)%ndim
                args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                c_args(j) = args(i)%ndim_ptr
                j = j + 1
                args(i)%shape_ptr = c_loc(args(i)%shape_c(1))
                c_args(j) = args(i)%shape_ptr
                j = j + 1
             end if
          else
             if (is_format) then
                args(i)%len_ptr = c_args(1)
             else if (is_next_size_t(args, i)) then
                args(i)%len_ptr = args(i+1)%ptr
             else if (args(i)%alloc) then
                args(i)%len_c = args(i)%len
                args(i)%len_ptr = c_loc(args(i)%len_c)
                c_args(j) = args(i)%len_ptr
                j = j + 1
             end if
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (is_next_size_t(args, i)) then
             args(i)%prec_ptr = args(i+1)%ptr
          else
             args(i)%prec_c = args(i)%prec
             args(i)%prec_ptr = c_loc(args(i)%prec_c)
             c_args(j) = args(i)%prec_ptr
             j = j + 1
          end if
       end if
    end do
    call ygglog_debug("pre_send: end")
  end function pre_send

  function pre_recv(args, c_args, is_format) result(c_nargs)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: is_format
    integer(kind=c_int) :: c_nargs
    integer(kind=c_size_t) :: k
    integer :: i, j
    integer :: nargs
    call ygglog_debug("pre_recv: begin")
    nargs = size(args)  ! Number of arguments passed
    c_nargs = nargs  ! Number of arguments that C should be aware of
    if ((is_format).and.(nargs.gt.0)) then
       if (.not.is_size_t(args(1))) then
          nargs = nargs + 1
          c_nargs = c_nargs + 1
       end if
    end if
    do i = 1, size(args)
       allocate(args(i)%len_c)
       allocate(args(i)%prec_c)
       allocate(args(i)%ndim_c)
       args(i)%len_c = 1
       args(i)%prec_c = 1
       args(i)%ndim_c = 1
       if (associated(args(i)%shape)) then
          allocate(args(i)%shape_c(args(i)%ndim))
          do k = 1, args(i)%ndim
             args(i)%shape_c(k) = args(i)%shape(k)
          end do
       end if
       if (args(i)%array) then
          if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                ! Do nothing, vars already exist
             else if (is_next_size_t(args, i, req_array=.true.)) then
                nargs = nargs + 1  ! For ndim
                if (args(i)%alloc) then
                   c_nargs = c_nargs + 1
                end if
             else
                nargs = nargs + 2  ! For ndim and shape
                if (args(i)%alloc) then
                   c_nargs = c_nargs + 2
                end if
             end if
          else
             if ((.not.is_format).and.(.not.is_next_size_t(args, i))) then
                nargs = nargs + 1  ! For the array size
                if (args(i)%alloc) then
                   c_nargs = c_nargs + 1
                end if
             end if
          end if
          if ((args(i)%type.eq."character").or. &
               (args(i)%type.eq."unicode")) then
             nargs = nargs + 1  ! For the string length
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (.not.is_next_size_t(args, i)) then
             nargs = nargs + 1  ! For the string size
             c_nargs = c_nargs + 1
          end if
       end if
    end do
    allocate(c_args(nargs))
    call ygglog_debug("pre_recv: counted and allocated for arguments")
    j = 1
    if (is_format) then
       if (.not.is_size_t(args(1))) then
          args(1)%len_c = args(1)%len
          args(1)%len_ptr = c_loc(args(1)%len_c)
          c_args(j) = args(1)%len_ptr
          j = j + 1
       end if
    end if
    do i = 1, size(args)
       c_args(j) = args(i)%ptr
       j = j + 1
       if (args(i)%array) then
          ! TODO: handle case where shape is explicit and ensure
          ! that length of shape variable is not appended
          if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
             if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                args(i)%ndim_ptr = args(i+1)%ptr
                args(i)%shape_ptr = args(i+2)%ptr
             else if (is_next_size_t(args, i, req_array=.true.)) then
                args(i)%shape_ptr = args(i+1)%ptr
                args(i)%ndim_c = args(i)%ndim
                args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                c_args(j) = args(i)%ndim_ptr
                j = j + 1
             else
                args(i)%ndim_c = args(i)%ndim
                args(i)%ndim_ptr = c_loc(args(i)%ndim_c)
                c_args(j) = args(i)%ndim_ptr
                j = j + 1
                if (associated(args(i)%shape_c)) then
                   args(i)%shape_ptr = c_loc(args(i)%shape_c(1))
                else
                   args(i)%shape_ptr = c_null_ptr
                end if
                c_args(j) = args(i)%shape_ptr
                j = j + 1
             end if
          else
             if (is_format) then
                args(i)%len_ptr = c_args(1)
             else if (is_next_size_t(args, i)) then
                args(i)%len_ptr = args(i+1)%ptr
             else
                args(i)%len_c = args(i)%len
                args(i)%len_ptr = c_loc(args(i)%len_c)
                c_args(j) = args(i)%len_ptr
                j = j + 1
             end if
          end if
          if ((args(i)%type.eq."character").or. &
               (args(i)%type.eq."unicode")) then
             args(i)%prec_c = args(i)%prec
             args(i)%prec_ptr = c_loc(args(i)%prec_c)
             c_args(j) = args(i)%prec_ptr
             j = j + 1
          end if
       else if ((args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")) then
          if (is_next_size_t(args, i)) then
             args(i)%prec_ptr = args(i+1)%ptr
          else
             args(i)%prec_c = args(i)%prec
             args(i)%prec_ptr = c_loc(args(i)%prec_c)
             c_args(j) = args(i)%prec_ptr
             j = j + 1
          end if
       end if
    end do
    call ygglog_debug("pre_recv: end")
  end function pre_recv

  subroutine post_recv(args, c_args, flag, realloc, is_format)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: flag
    integer :: i, j
    logical :: realloc, is_format
    call ygglog_debug("post_recv: begin")
    if (flag) then
       j = 1
       if (is_format) then
          if (.not.is_size_t(args(1))) then
             j = j + 1
          end if
       end if
       do i = 1, size(args)
          args(i)%ptr = c_args(j)
          if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
             args(i)%shape_ptr = c_args(j+2)
          end if
          flag = yggptr_c2f(args(i), realloc)
          if (.not.flag) then
             call ygglog_error("Error recovering fortran pointer for variable.")
             exit
          end if
          j = j + 1
          if (args(i)%array) then
             if ((args(i)%ndim.gt.1).or.args(i)%ndarray) then
                if (is_next_size_t(args, i).and.is_next_size_t(args, i+1, req_array=.true.)) then
                   ! Do nothing, process variables as normal
                else if (is_next_size_t(args, i, req_array=.true.)) then
                   j = j + 1
                else
                   j = j + 2
                end if
             else
                if ((.not.is_format).and.(.not.is_next_size_t(args, i))) then
                   j = j + 1
                end if
             end if
             if ((args(i)%type.eq."character").or. &
                  (args(i)%type.eq."unicode")) then
                j = j + 1
             end if
          else if ((args(i)%type.eq."character").or. &
               (args(i)%type.eq."unicode")) then
             if (.not.is_next_size_t(args, i)) then
                j = j + 1
             end if
          end if
       end do
    end if
    if (flag) then
       do i = 1, size(args)
          deallocate(args(i)%len_c)
          deallocate(args(i)%prec_c)
          deallocate(args(i)%ndim_c)
          if (associated(args(i)%shape_c)) then
             deallocate(args(i)%shape_c)
          end if
       end do
    end if
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
    call ygglog_debug("post_recv: end")
  end subroutine post_recv

  subroutine post_send(args, c_args, flag)
    implicit none
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    logical :: flag
    integer :: i
    call ygglog_debug("post_send: begin")
    if (flag) then
       do i = 1, size(args)
          deallocate(args(i)%len_c)
          deallocate(args(i)%prec_c)
          deallocate(args(i)%ndim_c)
          deallocate(args(i)%shape_c)
       end do
    end if
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
    call ygglog_debug("post_send: end")
  end subroutine post_send

  function ygg_rpc_call_1v1(ygg_q, oarg, iarg) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oarg
    type(yggptr) :: iarg
    logical :: flag
    flag = ygg_rpc_call_mult(ygg_q, [oarg], [iarg])
  end function ygg_rpc_call_1v1
  function ygg_rpc_call_1vm(ygg_q, oarg, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oarg
    type(yggptr) :: iargs(:)
    logical :: flag
    flag = ygg_rpc_call_mult(ygg_q, [oarg], iargs)
  end function ygg_rpc_call_1vm
  function ygg_rpc_call_mv1(ygg_q, oargs, iarg) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iarg
    logical :: flag
    flag = ygg_rpc_call_mult(ygg_q, oargs, [iarg])
  end function ygg_rpc_call_mv1
  function ygg_rpc_call_mult(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iargs(:)
    type(c_ptr), allocatable, target :: c_args(:)
    type(c_ptr), allocatable, target :: c_iargs(:)
    type(c_ptr), allocatable, target :: c_oargs(:)
    integer :: c_nargs
    logical :: flag
    integer :: i
    integer(kind=c_int) :: c_flag
    logical :: iis_format, ois_format
    ois_format = is_comm_format_array_type(ygg_q, oargs)
    iis_format = is_comm_format_array_type(ygg_q, iargs)
    c_ygg_q = ygg_q%comm
    c_nargs = 0
    c_nargs = c_nargs + pre_send(oargs, c_oargs, ois_format)
    c_nargs = c_nargs + pre_recv(iargs, c_iargs, iis_format)
    allocate(c_args(size(c_oargs) + size(c_iargs)))
    do i = 1, size(c_oargs)
       c_args(i) = c_oargs(i)
    end do
    do i = 1, size(c_iargs)
       c_args(i + size(c_oargs)) = c_iargs(i)
    end do
    c_flag = ygg_rpc_call_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
    do i = 1, size(c_iargs)
       c_iargs(i) = c_args(i + size(c_oargs))
    end do
    call post_send(oargs, c_oargs, flag)
    call post_recv(iargs, c_iargs, flag, .false., iis_format)
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
  end function ygg_rpc_call_mult
  
  function ygg_rpc_call_realloc_1v1(ygg_q, oarg, iarg) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oarg
    type(yggptr) :: iarg
    logical :: flag
    flag = ygg_rpc_call_realloc_mult(ygg_q, [oarg], [iarg])
  end function ygg_rpc_call_realloc_1v1
  function ygg_rpc_call_realloc_1vm(ygg_q, oarg, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oarg
    type(yggptr) :: iargs(:)
    logical :: flag
    flag = ygg_rpc_call_realloc_mult(ygg_q, [oarg], iargs)
  end function ygg_rpc_call_realloc_1vm
  function ygg_rpc_call_realloc_mv1(ygg_q, oargs, iarg) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iarg
    logical :: flag
    flag = ygg_rpc_call_realloc_mult(ygg_q, oargs, [iarg])
  end function ygg_rpc_call_realloc_mv1
  function ygg_rpc_call_realloc_mult(ygg_q, oargs, iargs) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: oargs(:)
    type(yggptr) :: iargs(:)
    type(c_ptr), allocatable, target :: c_args(:)
    type(c_ptr), allocatable, target :: c_oargs(:)
    type(c_ptr), allocatable, target :: c_iargs(:)
    integer :: c_nargs
    logical :: flag, iis_format, ois_format
    integer(kind=c_int) :: c_flag
    integer :: i
    c_ygg_q = ygg_q%comm
    ois_format = is_comm_format_array_type(ygg_q, oargs)
    iis_format = is_comm_format_array_type(ygg_q, iargs)
    flag = .true.
    do i = 1, size(iargs)
       if ((iargs(i)%array.or.(iargs(i)%type.eq."character").or. &
            (iargs(i)%type.eq."unicode")).and. &
            (.not.(iargs(i)%alloc))) then
          call ygglog_error("Provided array/string is not allocatable.")
          flag = .false.
       end if
    end do
    if (flag) then
       c_nargs = 0
       c_nargs = c_nargs + pre_send(oargs, c_oargs, ois_format)
       c_nargs = c_nargs + pre_recv(iargs, c_iargs, iis_format)
       allocate(c_args(size(c_oargs) + size(c_iargs)))
       do i = 1, size(c_oargs)
          c_args(i) = c_oargs(i)
       end do
       do i = 1, size(c_iargs)
          c_args(i + size(c_oargs)) = c_iargs(i)
       end do
       c_flag = ygg_rpc_call_realloc_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
       if (c_flag.ge.0) then
          flag = .true.
       else
          flag = .false.
       end if
       do i = 1, size(c_iargs)
          c_iargs(i) = c_args(i + size(c_oargs))
       end do
    end if
    call post_send(oargs, c_oargs, flag)
    call post_recv(iargs, c_iargs, flag, .true., iis_format)
    if (allocated(c_args)) then
       deallocate(c_args)
    end if
  end function ygg_rpc_call_realloc_mult
  
  function ygg_recv_var_sing(ygg_q, arg) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: arg
    logical :: flag
    flag = ygg_recv_var_mult(ygg_q, [arg])
  end function ygg_recv_var_sing
  function ygg_recv_var_mult(ygg_q, args) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr) :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    integer :: c_nargs
    logical :: flag, is_format
    integer(kind=c_int) :: c_flag
    is_format = is_comm_format_array_type(ygg_q, args)
    c_ygg_q = ygg_q%comm
    c_nargs = pre_recv(args, c_args, is_format)
    c_flag = ygg_recv_var_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
    if (c_flag.ge.0) then
       flag = .true.
    else
       flag = .false.
    end if
    call post_recv(args, c_args, flag, .false., is_format)
  end function ygg_recv_var_mult

  function ygg_recv_var_realloc_sing(ygg_q, arg) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(yggptr) :: arg
    logical :: flag
    flag = ygg_recv_var_realloc_mult(ygg_q, [arg])
  end function ygg_recv_var_realloc_sing
  function ygg_recv_var_realloc_mult(ygg_q, args) result (flag)
    implicit none
    type(yggcomm) :: ygg_q
    type(c_ptr) :: c_ygg_q
    type(yggptr), target :: args(:)
    type(c_ptr), allocatable, target :: c_args(:)
    integer :: c_nargs
    logical :: flag, is_format
    integer :: i
    integer(kind=c_int) :: c_flag
    call ygglog_debug("ygg_recv_var_realloc: begin")
    is_format = is_comm_format_array_type(ygg_q, args)
    c_ygg_q = ygg_q%comm
    flag = .true.
    do i = 1, size(args)
       if ((args(i)%array.or.(args(i)%type.eq."character").or. &
            (args(i)%type.eq."unicode")).and. &
            (.not.(args(i)%alloc))) then
          call ygglog_error("Provided array/string is not allocatable.")
          flag = .false.
       end if
    end do
    call ygglog_debug("ygg_recv_var_realloc: checked variables")
    if (flag) then
       c_nargs = pre_recv(args, c_args, is_format)
       c_flag = ygg_recv_var_realloc_c(c_ygg_q, c_nargs, c_loc(c_args(1)))
       if (c_flag.ge.0) then
          flag = .true.
       else
          flag = .false.
       end if
    end if
    call post_recv(args, c_args, flag, .true., is_format)
    call ygglog_debug("ygg_recv_var_realloc: end")
  end function ygg_recv_var_realloc_mult

  ! Ply interface
  function init_ply() result (out)
    implicit none
    type(yggply) :: out
    out = init_ply_c()
  end function init_ply
  subroutine free_ply(p)
    implicit none
    type(yggply), target :: p
    type(yggply), pointer :: pp
    type(c_ptr) :: c_p
    pp => p
    c_p = c_loc(pp)
    call free_ply_c(c_p)
    nullify(pp)
  end subroutine free_ply
  function copy_ply(p) result(out)
    implicit none
    type(yggply), intent(in) :: p
    type(yggply) :: out
    out = copy_ply_c(p)
  end function copy_ply
  subroutine display_ply_indent(p, indent)
    implicit none
    type(yggply), intent(in) :: p
    character(len=*), intent(in) :: indent
    character(len=len(indent)+1) :: c_indent
    c_indent = indent//c_null_char
    call display_ply_indent_c(p, c_indent)
  end subroutine display_ply_indent
  subroutine display_ply(p)
    implicit none
    type(yggply), intent(in) :: p
    call display_ply_c(p)
  end subroutine display_ply
  
  ! Obj interface
  function init_obj() result (out)
    implicit none
    type(yggobj) :: out
    out = init_obj_c()
  end function init_obj
  subroutine free_obj(p)
    implicit none
    type(yggobj), target :: p
    type(yggobj), pointer :: pp
    type(c_ptr) :: c_p
    pp => p
    c_p = c_loc(pp)
    call free_obj_c(c_p)
    nullify(pp)
  end subroutine free_obj
  function copy_obj(p) result(out)
    implicit none
    type(yggobj), intent(in) :: p
    type(yggobj) :: out
    out = copy_obj_c(p)
  end function copy_obj
  subroutine display_obj_indent(p, indent)
    implicit none
    type(yggobj), intent(in) :: p
    character(len=*), intent(in) :: indent
    character(len=len(indent)+1) :: c_indent
    c_indent = indent//c_null_char
    call display_obj_indent_c(p, c_indent)
  end subroutine display_obj_indent
  subroutine display_obj(p)
    implicit none
    type(yggobj), intent(in) :: p
    call display_obj_c(p)
  end subroutine display_obj

  ! Generic interface
  function init_generic() result(out)
    implicit none
    type(ygggeneric) :: out
    out = init_generic_c()
  end function init_generic
  function init_generic_array() result(out)
    implicit none
    type(ygggeneric) :: out
    out = init_generic_array_c()
  end function init_generic_array
  function init_generic_map() result(out)
    implicit none
    type(ygggeneric) :: out
    out = init_generic_map_c()
  end function init_generic_map
  function create_generic(type_class, data) result(out)
    implicit none
    type(yggdtype) :: type_class
    type(yggptr) :: data
    integer(kind=c_size_t) :: nbytes
    type(c_ptr) :: c_type_class
    type(c_ptr) :: c_data
    type(ygggeneric) :: out
    c_type_class = type_class%ptr
    c_data = data%ptr
    nbytes = data%nbytes
    out = create_generic_c(c_type_class, c_data, nbytes)
  end function create_generic
  subroutine free_generic(x)
    implicit none
    type(ygggeneric), target :: x
    integer(kind=c_int) :: out
    out = free_generic_c(c_loc(x))
    if (out.ne.0) then
       stop "Error freeing generic object."
    end if
  end subroutine free_generic
  function is_generic_init(x) result(out)
    implicit none
    type(ygggeneric), value, intent(in) :: x
    logical :: out
    integer(kind=c_int) :: c_out
    out = .false.
    c_out = is_generic_init_c(x)
    if (c_out.ne.0) then
       out = .true.
    end if
  end function is_generic_init
  function copy_generic(src) result(out)
    implicit none
    type(ygggeneric), intent(in) :: src
    type(ygggeneric) :: out
    out = copy_generic_c(src)
  end function copy_generic
  subroutine display_generic(x)
    implicit none
    type(ygggeneric), intent(in) :: x
    call display_generic_c(x)
  end subroutine display_generic
  function add_generic_array(arr, x) result(out)
    implicit none
    type(ygggeneric) :: arr
    type(ygggeneric), intent(in) :: x
    integer(kind=c_int) :: out
    out = add_generic_array_c(arr, x)
  end function add_generic_array
  function set_generic_array(arr, i, x) result(out)
    implicit none
    type(ygggeneric) :: arr
    integer(kind=c_size_t), intent(in) :: i
    type(ygggeneric), intent(in) :: x
    integer(kind=c_int) :: out
    out = set_generic_array_c(arr, i-1, x)
  end function set_generic_array
  function get_generic_array(arr, i, x) result(out)
    implicit none
    type(ygggeneric), intent(in) :: arr
    integer(kind=c_size_t), intent(in) :: i
    type(ygggeneric), pointer :: x
    integer(kind=c_int) :: out
    type(c_ptr) :: c_x
    allocate(x);
    c_x = c_loc(x) ! Maybe use first element in type
    out = get_generic_array_c(arr, i-1, c_x)
  end function get_generic_array
  function set_generic_object(arr, k, x) result(out)
    implicit none
    type(ygggeneric) :: arr
    character(len=*), intent(in) :: k
    type(ygggeneric), intent(in) :: x
    integer(kind=c_int) :: out
    character(len=len_trim(k)+1) :: c_k
    c_k = trim(k)//c_null_char
    out = set_generic_object_c(arr, c_k, x)
  end function set_generic_object
  function get_generic_object(arr, k, x) result(out)
    implicit none
    type(ygggeneric), intent(in) :: arr
    character(len=*), intent(in) :: k
    type(ygggeneric), pointer, intent(out) :: x
    integer(kind=c_int) :: out
    character(len=len_trim(k)+1) :: c_k
    type(c_ptr) :: c_x
    allocate(x);
    c_k = trim(k)//c_null_char
    c_x = c_loc(x) ! Maybe use first element in type
    out = get_generic_object_c(arr, c_k, c_x)
  end function get_generic_object

  ! Python interface
  function init_python() result(out)
    implicit none
    type(yggpython) :: out
    out = init_python_c()
  end function init_python
  subroutine free_python(x)
    implicit none
    type(yggpython), target :: x
    type(yggpython), pointer :: xp
    type(c_ptr) :: c_x
    xp => x
    c_x = c_loc(xp)
    call free_python_c(c_x)
    nullify(xp)
  end subroutine free_python
  function copy_python(x) result(out)
    implicit none
    type(yggpython) :: x
    type(yggpython) :: out
    out = copy_python_c(x)
  end function copy_python
  subroutine display_python(x)
    implicit none
    type(yggpython) :: x
    call display_python_c(x)
  end subroutine display_python

  ! Interface for getting/setting generic array elements
  ! Get
  function generic_array_get_size(x) result(out)
    implicit none
    type(ygggeneric) :: x
    integer(kind=c_size_t) :: out
    out = generic_array_get_size_c(x)
  end function generic_array_get_size
  function generic_array_get_item(x, index, typename) result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: typename
    type(c_ptr) :: out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    out = generic_array_get_item_c(x, int(index-1, c_size_t), c_typename)
  end function generic_array_get_item
  function generic_array_get_item_nbytes(x, index) result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    integer(kind=c_int) :: out
    out = generic_array_get_item_nbytes_c(x, int(index-1, c_size_t))
    if (out.lt.0) then
       stop "Error getting number of bytes in array item."
    end if
  end function generic_array_get_item_nbytes
  function generic_array_get_scalar(x, index, subtype, precision) result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    c_subtype = trim(subtype)//c_null_char
    out = generic_array_get_scalar_c(x, int(index-1, c_size_t), &
         c_subtype, int(precision, c_size_t))
  end function generic_array_get_scalar
  function generic_array_get_1darray(x, index, subtype, precision, data) &
       result(out)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    type(c_ptr), value :: data
    integer(kind=c_size_t) :: out
    character(len=len_trim(subtype)+1) :: c_subtype
    c_subtype = trim(subtype)//c_null_char
    out = generic_array_get_1darray_c(x, int(index-1, c_size_t), &
         c_subtype, int(precision, c_size_t), data)
  end function generic_array_get_1darray
  function generic_array_get_ndarray(x, index, subtype, precision, &
       data) result(shape)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    type(c_ptr), value :: data
    integer(kind=c_size_t), dimension(:), pointer :: shape
    integer(kind=c_size_t) :: ndim
    character(len=len_trim(subtype)+1) :: c_subtype
    type(c_ptr), target :: c_shape
    c_subtype = trim(subtype)//c_null_char
    ndim = generic_array_get_ndarray_c(x, int(index-1, c_size_t), &
         subtype, int(precision, c_size_t), data, c_loc(c_shape))
    call c_f_pointer(c_shape, shape, [ndim])
  end function generic_array_get_ndarray
  ! Set
  subroutine generic_array_set_item(x, index, typename, val)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    character(len=*), intent(in) :: typename
    type(c_ptr) :: val
    integer(kind=c_int) :: c_out
    character(len=len_trim(typename)+1) :: c_typename
    c_typename = trim(typename)//c_null_char
    c_out = generic_array_set_item_c(x, int(index-1, c_size_t), &
         c_typename, val)
    if (c_out.lt.0) then
       stop "Error setting element in array."
    end if
  end subroutine generic_array_set_item
  subroutine generic_array_set_scalar(x, index, val, subtype, &
       precision, units_in)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    type(c_ptr) :: val
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_array_set_scalar_c(x, int(index-1, c_size_t), &
         val, c_subtype, int(precision, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting scalar element in array."
    end if
  end subroutine generic_array_set_scalar
  subroutine generic_array_set_1darray(x, index, val, subtype, &
       precision, length, units_in)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    type(c_ptr) :: val
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: length
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_array_set_1darray_c(x, int(index-1, c_size_t), &
         val, c_subtype, int(precision, c_size_t), &
         int(length, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting 1darray element in array."
    end if
  end subroutine generic_array_set_1darray
  subroutine generic_array_set_ndarray(x, index, data, subtype, &
       precision, shape, units_in)
    implicit none
    type(ygggeneric) :: x
    integer, intent(in) :: index
    type(c_ptr) :: data
    character(len=*), intent(in) :: subtype
    integer, intent(in) :: precision
    integer(kind=c_size_t), dimension(:), intent(in), target :: shape
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_array_set_ndarray_c(x, int(index-1, c_size_t), &
         data, c_subtype, int(precision, c_size_t), &
         int(size(shape), c_size_t), c_loc(shape), c_units)
    if (c_out.lt.0) then
       stop "Error setting ndarray element in array."
    end if
  end subroutine generic_array_set_ndarray

  ! Interface for getting/setting generic map elements
  ! Get
  function generic_map_get_size(x) result(out)
    implicit none
    type(ygggeneric) :: x
    integer(kind=c_size_t) :: out
    out = generic_map_get_size_c(x)
  end function generic_map_get_size
  subroutine generic_map_get_keys(x, keys)
    implicit none
    type(ygggeneric) :: x
    character(len=*), dimension(:), pointer, intent(out) :: keys
    integer(kind=c_size_t), target :: n_keys
    integer(kind=c_size_t), target :: key_size
    integer(kind=c_size_t) :: i, j
    type(c_ptr) :: c_keys
    character, dimension(:), pointer :: f_keys
    c_keys = generic_map_get_keys_c(x, c_loc(n_keys), c_loc(key_size))
    if (.not.c_associated(c_keys)) then
      stop "Error getting keys from map."
    endif
    call c_f_pointer(c_keys, f_keys, [n_keys * key_size])
    allocate(keys(n_keys))
    if (key_size.gt.len(keys(1))) then
      stop "Key size is greater than size of provided keys."
    endif
    ! Allocation of character length and array dimension in gfortran
    ! has a bug which is fixed in gfortran 9.1 and the version on
    ! conda-forge as m2w64-gcc-fortran is only 5.3 as of 2020/6/18
    ! so for now the keys pointer needs to have a defined character
    ! length.
    ! allocate(character(len=key_size) :: keys(n_keys))
    do i = 1, n_keys
       do j = 1, key_size
          keys(i)(j:j) = f_keys(((i-1)*key_size)+j)
       end do
       do j = key_size+1, len(keys(1))
          keys(i)(j:j) = ' '
       end do
    end do
    deallocate(f_keys)
  end subroutine generic_map_get_keys
  function generic_map_get_item(x, key, typename) result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: typename
    type(c_ptr) :: out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(typename)+1) :: c_typename
    c_key = trim(key)//c_null_char
    c_typename = trim(typename)//c_null_char
    out = generic_map_get_item_c(x, c_key, c_typename)
  end function generic_map_get_item
  function generic_map_get_item_nbytes(x, key) result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    integer(kind=c_int) :: out
    character(len=len_trim(key)+1) :: c_key
    c_key = trim(key)//c_null_char
    out = generic_map_get_item_nbytes_c(x, c_key)
    if (out.lt.0) then
       stop "Error getting number of bytes in map item."
    end if
  end function generic_map_get_item_nbytes
  function generic_map_get_scalar(x, key, subtype, precision) result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    out = generic_map_get_scalar_c(x, c_key, c_subtype, &
         int(precision, c_size_t))
  end function generic_map_get_scalar
  function generic_map_get_1darray(x, key, subtype, precision, data) &
       result(out)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: data
    integer(kind=c_size_t) :: out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    out = generic_map_get_1darray_c(x, c_key, c_subtype, &
         int(precision, c_size_t), data)
  end function generic_map_get_1darray
  function generic_map_get_ndarray(x, key, subtype, precision, data) &
       result(shape)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: subtype
    integer, intent(in) :: precision
    type(c_ptr) :: data
    integer(kind=c_size_t), dimension(:), pointer :: shape
    integer(kind=c_size_t) :: ndim
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    type(c_ptr), target :: c_shape
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    ndim = generic_map_get_ndarray_c(x, c_key, c_subtype, &
         int(precision, c_size_t), data, c_loc(c_shape))
    call c_f_pointer(c_shape, shape, [ndim])
  end function generic_map_get_ndarray
  ! Set
  subroutine generic_map_set_item(x, key, typename, val)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    character(len=*) :: typename
    type(c_ptr) :: val
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(typename)+1) :: c_typename
    c_key = trim(key)//c_null_char
    c_typename = trim(typename)//c_null_char
    c_out = generic_map_set_item_c(x, c_key, c_typename, val)
    if (c_out.lt.0) then
       stop "Error setting element in map."
    end if
  end subroutine generic_map_set_item
  subroutine generic_map_set_scalar(x, key, val, subtype, precision, &
       units_in)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    type(c_ptr) :: val
    character(len=*) :: subtype
    integer, intent(in) :: precision
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       allocate(character(len=0) :: units)
       units = ""
    end if
    allocate(character(len=len_trim(units)+1) :: c_units)
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_map_set_scalar_c(x, c_key, val, c_subtype, &
         int(precision, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting scalar element in map."
    end if
    deallocate(c_units)
  end subroutine generic_map_set_scalar
  subroutine generic_map_set_1darray(x, key, val, subtype, &
       precision, length, units_in)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    type(c_ptr) :: val
    character(len=*) :: subtype
    integer, intent(in) :: precision
    integer, intent(in) :: length
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_map_set_1darray_c(x, c_key, val, c_subtype, &
         int(precision, c_size_t), int(length, c_size_t), c_units)
    if (c_out.lt.0) then
       stop "Error setting 1darray element in map."
    end if
  end subroutine generic_map_set_1darray
  subroutine generic_map_set_ndarray(x, key, data, subtype, &
       precision, shape, units_in)
    implicit none
    type(ygggeneric) :: x
    character(len=*) :: key
    type(c_ptr) :: data
    character(len=*) :: subtype
    integer, intent(in) :: precision
    integer(kind=c_size_t), dimension(:), intent(in), target :: shape
    character(len=*), intent(in), optional, target :: units_in
    character(len=:), pointer :: units
    integer(kind=c_int) :: c_out
    character(len=len_trim(key)+1) :: c_key
    character(len=len_trim(subtype)+1) :: c_subtype
    character(len=:), pointer :: c_units
    if (present(units_in)) then
       units => units_in
    else
       units = ""
    end if
    c_key = trim(key)//c_null_char
    c_subtype = trim(subtype)//c_null_char
    c_units = trim(units)//c_null_char
    c_out = generic_map_set_ndarray_c(x, c_key, data, c_subtype, &
         int(precision, c_size_t), int(size(shape), c_size_t), &
         c_loc(shape), c_units)
    if (c_out.lt.0) then
       stop "Error setting ndarray element in map."
    end if
  end subroutine generic_map_set_ndarray
  
end module fygg

module hellofunc
contains
  subroutine my_print(msg)
    implicit none
    character(len=*), intent(in) :: msg
    write(*, '("myPrint: ",A)') trim(msg)
  end subroutine my_print

end module hellofunc

function yggptr_realloc(x, array_shape, precision, realloc) result(flag)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), dimension(:), pointer :: array_shape
  integer(kind=c_size_t), pointer :: precision
  logical :: realloc, flag
  character(len=500) :: log_msg
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t) :: old_len = 1
  integer(kind=c_size_t) :: i
  call ygglog_debug("yggptr_realloc: begin")
  allocate(array_len)
  array_len = 1
  if (x%array) then
     if ((x%ndim.gt.1).or.x%ndarray) then
        if (associated(x%shape)) then
           do i = 1, x%ndim
              old_len = old_len * x%shape(i)
           end do
        end if
        do i = 1, size(array_shape)
           array_len = array_len * array_shape(i)
        end do
     else
        old_len = x%len
        array_len = array_shape(1)
     end if
  end if
  call ygglog_debug("yggptr_realloc: set length")
  flag = .true.
  if ((x%array.and.(array_len.gt.old_len)).or. &
       ((x%type.eq."character").and.(precision.gt.x%prec))) then
     if (realloc.and.x%alloc) then
        write(log_msg, '("yggptr_realloc: begin realloc. &
             &size: ",i7,i7," precision: ",i7,i7)') &
             old_len, array_len, x%prec, precision
        call ygglog_debug(log_msg)
        select type(item=>x%item)
        type is (yggchar_r)
           call yggptr_realloc_character(x, array_len, precision)
        type is (c_long_1d)
           call yggptr_realloc_1darray_integer(x, array_len, precision)
        type is (integer_1d)
           call yggptr_realloc_1darray_integer(x, array_len, precision)
        type is (integer2_1d)
           call yggptr_realloc_1darray_integer(x, array_len, precision)
        type is (integer4_1d)
           call yggptr_realloc_1darray_integer(x, array_len, precision)
        type is (integer8_1d)
           call yggptr_realloc_1darray_integer(x, array_len, precision)
        type is (real_1d)
           call yggptr_realloc_1darray_real(x, array_len, precision)
        type is (real4_1d)
           call yggptr_realloc_1darray_real(x, array_len, precision)
        type is (real8_1d)
           call yggptr_realloc_1darray_real(x, array_len, precision)
        type is (real16_1d)
           call yggptr_realloc_1darray_real(x, array_len, precision)
        type is (complex_1d)
           call yggptr_realloc_1darray_complex(x, array_len, precision)
        type is (complex4_1d)
           call yggptr_realloc_1darray_complex(x, array_len, precision)
        type is (complex8_1d)
           call yggptr_realloc_1darray_complex(x, array_len, precision)
        type is (complex16_1d)
           call yggptr_realloc_1darray_complex(x, array_len, precision)
        type is (logical_1d)
           call yggptr_realloc_1darray_logical(x, array_len, precision)
        type is (logical1_1d)
           call yggptr_realloc_1darray_logical(x, array_len, precision)
        type is (logical2_1d)
           call yggptr_realloc_1darray_logical(x, array_len, precision)
        type is (logical4_1d)
           call yggptr_realloc_1darray_logical(x, array_len, precision)
        type is (logical8_1d)
           call yggptr_realloc_1darray_logical(x, array_len, precision)
        type is (character_1d)
           call yggptr_realloc_1darray_character(x, array_len, precision)
        type is (c_long_nd)
           call yggptr_realloc_ndarray_integer(x, array_len, precision)
        type is (integer_nd)
           call yggptr_realloc_ndarray_integer(x, array_len, precision)
        type is (integer2_nd)
           call yggptr_realloc_ndarray_integer(x, array_len, precision)
        type is (integer4_nd)
           call yggptr_realloc_ndarray_integer(x, array_len, precision)
        type is (integer8_nd)
           call yggptr_realloc_ndarray_integer(x, array_len, precision)
        type is (real_nd)
           call yggptr_realloc_ndarray_real(x, array_len, precision)
        type is (real4_nd)
           call yggptr_realloc_ndarray_real(x, array_len, precision)
        type is (real8_nd)
           call yggptr_realloc_ndarray_real(x, array_len, precision)
        type is (real16_nd)
           call yggptr_realloc_ndarray_real(x, array_len, precision)
        type is (complex_nd)
           call yggptr_realloc_ndarray_complex(x, array_len, precision)
        type is (complex4_nd)
           call yggptr_realloc_ndarray_complex(x, array_len, precision)
        type is (complex8_nd)
           call yggptr_realloc_ndarray_complex(x, array_len, precision)
        type is (complex16_nd)
           call yggptr_realloc_ndarray_complex(x, array_len, precision)
        type is (logical_nd)
           call yggptr_realloc_ndarray_logical(x, array_len, precision)
        type is (logical1_nd)
           call yggptr_realloc_ndarray_logical(x, array_len, precision)
        type is (logical2_nd)
           call yggptr_realloc_ndarray_logical(x, array_len, precision)
        type is (logical4_nd)
           call yggptr_realloc_ndarray_logical(x, array_len, precision)
        type is (logical8_nd)
           call yggptr_realloc_ndarray_logical(x, array_len, precision)
        type is (character_nd)
           call yggptr_realloc_ndarray_character(x, array_len, precision)
        class default
           write(log_msg, '("yggptr_realloc: Unexpected type: ",A)') x%type
           call ygglog_error(log_msg)
           stop "ERROR"
        end select
        if (.not.associated(x%shape)) then
           allocate(x%shape(size(array_shape)))
           do i = 1, size(array_shape)
              x%shape(i) = array_shape(i)
           end do
           x%ndim = size(array_shape)
        else if (any(array_shape.gt.x%shape)) then
           x%shape = array_shape
           x%ndim = size(array_shape)
        end if
        if (array_len.gt.x%len) x%len = array_len
        if (precision.gt.x%prec) x%prec = precision
        call ygglog_debug("yggptr_realloc: done alloc")
     else
        flag = .false.
        if (.not.associated(x%shape)) then
           stop "Shape not associated"
        end if
        if (x%array.and.any(array_shape.gt.x%shape)) then
           write(log_msg, '("yggptr_realloc: Destination array has ", &
                &i7," elements, but ",i7," elements are expected.")') &
                old_len, array_len
           call ygglog_error(log_msg)
        end if
        if ((x%type.eq."character").and.(precision.gt.x%prec)) then
           write(log_msg, '("yggptr_realloc: Destination string has ", &
                &i7," elements, but ",i7," elements are expected.")') &
                x%prec, precision
           call ygglog_error(log_msg)
        end if
        stop "ERROR"
     end if
  end if
  deallocate(array_len)
  call ygglog_debug("yggptr_realloc: end")
end function yggptr_realloc


subroutine yggptr_realloc_character(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(yggchar_r), pointer :: x_character_realloc
  if (x%array) then
     stop 'yggptr_realloc_character (array): Unexpected type.'
  else
     select type(item=>x%item)
     type is (yggchar_r)
        x_character_realloc => item
        if (associated(x_character_realloc%x)) nullify(x_character_realloc%x)
     class default
        stop 'yggptr_realloc_character (scalar): Unexpected type.'
     end select
  end if
end subroutine yggptr_realloc_character


! 1d arrays
subroutine yggptr_realloc_1darray_integer(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(c_long_1d), pointer :: x_c_long_1d
  type(integer_1d), pointer :: x_integer_1d
  type(integer2_1d), pointer :: x_integer2_1d
  type(integer4_1d), pointer :: x_integer4_1d
  type(integer8_1d), pointer :: x_integer8_1d
  select type(item=>x%item)
  type is (c_long_1d)
     x_c_long_1d => item
     if (associated(x_c_long_1d%x)) nullify(x_c_long_1d%x)
  type is (integer_1d)
     x_integer_1d => item
     if (associated(x_integer_1d%x)) nullify(x_integer_1d%x)
  type is (integer2_1d)
     x_integer2_1d => item
     if (associated(x_integer2_1d%x)) nullify(x_integer2_1d%x)
  type is (integer4_1d)
     x_integer4_1d => item
     if (associated(x_integer4_1d%x)) nullify(x_integer4_1d%x)
  type is (integer8_1d)
     x_integer8_1d => item
     if (associated(x_integer8_1d%x)) nullify(x_integer8_1d%x)
  class default
     stop 'yggptr_realloc_1darray_integer: Unexpected type.'
  end select
end subroutine yggptr_realloc_1darray_integer
subroutine yggptr_realloc_1darray_real(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(real_1d), pointer :: x_real_1d
  type(real4_1d), pointer :: x_real4_1d
  type(real8_1d), pointer :: x_real8_1d
  type(real16_1d), pointer :: x_real16_1d
  select type(item=>x%item)
  type is (real_1d)
     x_real_1d => item
     if (associated(x_real_1d%x)) nullify(x_real_1d%x)
  type is (real4_1d)
     x_real4_1d => item
     if (associated(x_real4_1d%x)) nullify(x_real4_1d%x)
  type is (real8_1d)
     x_real8_1d => item
     if (associated(x_real8_1d%x)) nullify(x_real8_1d%x)
  type is (real16_1d)
     x_real16_1d => item
     if (associated(x_real16_1d%x)) nullify(x_real16_1d%x)
  class default
     stop 'yggptr_realloc_1darray_real: Unexpected type.'
  end select
end subroutine yggptr_realloc_1darray_real
subroutine yggptr_realloc_1darray_complex(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(complex_1d), pointer :: x_complex_1d
  type(complex4_1d), pointer :: x_complex4_1d
  type(complex8_1d), pointer :: x_complex8_1d
  type(complex16_1d), pointer :: x_complex16_1d
  select type(item=>x%item)
  type is (complex_1d)
     x_complex_1d => item
     if (associated(x_complex_1d%x)) nullify(x_complex_1d%x)
  type is (complex4_1d)
     x_complex4_1d => item
     if (associated(x_complex4_1d%x)) nullify(x_complex4_1d%x)
  type is (complex8_1d)
     x_complex8_1d => item
     if (associated(x_complex8_1d%x)) nullify(x_complex8_1d%x)
  type is (complex16_1d)
     x_complex16_1d => item
     if (associated(x_complex16_1d%x)) nullify(x_complex16_1d%x)
  class default
     stop 'yggptr_realloc_1darray_complex: Unexpected type.'
  end select
end subroutine yggptr_realloc_1darray_complex
subroutine yggptr_realloc_1darray_logical(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(logical_1d), pointer :: x_logical_1d
  type(logical1_1d), pointer :: x_logical1_1d
  type(logical2_1d), pointer :: x_logical2_1d
  type(logical4_1d), pointer :: x_logical4_1d
  type(logical8_1d), pointer :: x_logical8_1d
  select type(item=>x%item)
  type is (logical_1d)
     x_logical_1d => item
     if (associated(x_logical_1d%x)) nullify(x_logical_1d%x)
  type is (logical1_1d)
     x_logical1_1d => item
     if (associated(x_logical1_1d%x)) nullify(x_logical1_1d%x)
  type is (logical2_1d)
     x_logical2_1d => item
     if (associated(x_logical2_1d%x)) nullify(x_logical2_1d%x)
  type is (logical4_1d)
     x_logical4_1d => item
     if (associated(x_logical4_1d%x)) nullify(x_logical4_1d%x)
  type is (logical8_1d)
     x_logical8_1d => item
     if (associated(x_logical8_1d%x)) nullify(x_logical8_1d%x)
  class default
     stop 'yggptr_realloc_1darray_logical: Unexpected type.'
  end select
end subroutine yggptr_realloc_1darray_logical
subroutine yggptr_realloc_1darray_character(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(character_1d), pointer :: x_character_1d
  integer(kind=8) :: i
  select type(item=>x%item)
  type is (character_1d)
     x_character_1d => item
     nullify(x%data_character_unit)
     if (array_len.gt.x%len) then
        if (associated(x_character_1d%x)) then
           deallocate(x_character_1d%x)
        end if
        allocate(x_character_1d%x(array_len))
     end if
     if ((array_len.gt.x%len).or.(precision.gt.x%prec)) then
        do i = 1, size(x_character_1d%x)
           if (associated(x_character_1d%x(i)%x)) then
              deallocate(x_character_1d%x(i)%x)
           end if
           allocate(x_character_1d%x(i)%x(precision))
        end do
     end if
  class default
     stop 'yggptr_realloc_1darray_character: Unexpected type.'
  end select
end subroutine yggptr_realloc_1darray_character

! nd arrays
subroutine yggptr_realloc_ndarray_integer(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(c_long_nd), pointer :: x_c_long_nd
  type(integer_nd), pointer :: x_integer_nd
  type(integer2_nd), pointer :: x_integer2_nd
  type(integer4_nd), pointer :: x_integer4_nd
  type(integer8_nd), pointer :: x_integer8_nd
  select type(item=>x%item)
  type is (c_long_nd)
     x_c_long_nd => item
     if (associated(x_c_long_nd%x)) nullify(x_c_long_nd%x)
     if (associated(x_c_long_nd%shape)) nullify(x_c_long_nd%shape)
  type is (integer_nd)
     x_integer_nd => item
     if (associated(x_integer_nd%x)) nullify(x_integer_nd%x)
     if (associated(x_integer_nd%shape)) nullify(x_integer_nd%shape)
  type is (integer2_nd)
     x_integer2_nd => item
     if (associated(x_integer2_nd%x)) nullify(x_integer2_nd%x)
     if (associated(x_integer2_nd%shape)) nullify(x_integer2_nd%shape)
  type is (integer4_nd)
     x_integer4_nd => item
     if (associated(x_integer4_nd%x)) nullify(x_integer4_nd%x)
     if (associated(x_integer4_nd%shape)) nullify(x_integer4_nd%shape)
  type is (integer8_nd)
     x_integer8_nd => item
     if (associated(x_integer8_nd%x)) nullify(x_integer8_nd%x)
     if (associated(x_integer8_nd%shape)) nullify(x_integer8_nd%shape)
  class default
     stop 'yggptr_realloc_ndarray_integer: Unexpected type.'
  end select
end subroutine yggptr_realloc_ndarray_integer
subroutine yggptr_realloc_ndarray_real(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(real_nd), pointer :: x_real_nd
  type(real4_nd), pointer :: x_real4_nd
  type(real8_nd), pointer :: x_real8_nd
  type(real16_nd), pointer :: x_real16_nd
  select type(item=>x%item)
  type is (real_nd)
     x_real_nd => item
     if (associated(x_real_nd%x)) nullify(x_real_nd%x)
     if (associated(x_real_nd%shape)) nullify(x_real_nd%shape)
  type is (real4_nd)
     x_real4_nd => item
     if (associated(x_real4_nd%x)) nullify(x_real4_nd%x)
     if (associated(x_real4_nd%shape)) nullify(x_real4_nd%shape)
  type is (real8_nd)
     x_real8_nd => item
     if (associated(x_real8_nd%x)) nullify(x_real8_nd%x)
     if (associated(x_real8_nd%shape)) nullify(x_real8_nd%shape)
  type is (real16_nd)
     x_real16_nd => item
     if (associated(x_real16_nd%x)) nullify(x_real16_nd%x)
     if (associated(x_real16_nd%shape)) nullify(x_real16_nd%shape)
  class default
     stop 'yggptr_realloc_ndarray_real: Unexpected type.'
  end select
end subroutine yggptr_realloc_ndarray_real
subroutine yggptr_realloc_ndarray_complex(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(complex_nd), pointer :: x_complex_nd
  type(complex4_nd), pointer :: x_complex4_nd
  type(complex8_nd), pointer :: x_complex8_nd
  type(complex16_nd), pointer :: x_complex16_nd
  select type(item=>x%item)
  type is (complex_nd)
     x_complex_nd => item
     if (associated(x_complex_nd%x)) nullify(x_complex_nd%x)
     if (associated(x_complex_nd%shape)) nullify(x_complex_nd%shape)
  type is (complex4_nd)
     x_complex4_nd => item
     if (associated(x_complex4_nd%x)) nullify(x_complex4_nd%x)
     if (associated(x_complex4_nd%shape)) nullify(x_complex4_nd%shape)
  type is (complex8_nd)
     x_complex8_nd => item
     if (associated(x_complex8_nd%x)) nullify(x_complex8_nd%x)
     if (associated(x_complex8_nd%shape)) nullify(x_complex8_nd%shape)
  type is (complex16_nd)
     x_complex16_nd => item
     if (associated(x_complex16_nd%x)) nullify(x_complex16_nd%x)
     if (associated(x_complex16_nd%shape)) nullify(x_complex16_nd%shape)
  class default
     stop 'yggptr_realloc_ndarray_complex: Unexpected type.'
  end select
end subroutine yggptr_realloc_ndarray_complex
subroutine yggptr_realloc_ndarray_logical(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(logical_nd), pointer :: x_logical_nd
  type(logical1_nd), pointer :: x_logical1_nd
  type(logical2_nd), pointer :: x_logical2_nd
  type(logical4_nd), pointer :: x_logical4_nd
  type(logical8_nd), pointer :: x_logical8_nd
  select type(item=>x%item)
  type is (logical_nd)
     x_logical_nd => item
     if (associated(x_logical_nd%x)) nullify(x_logical_nd%x)
     if (associated(x_logical_nd%shape)) nullify(x_logical_nd%shape)
  type is (logical1_nd)
     x_logical1_nd => item
     if (associated(x_logical1_nd%x)) nullify(x_logical1_nd%x)
     if (associated(x_logical1_nd%shape)) nullify(x_logical1_nd%shape)
  type is (logical2_nd)
     x_logical2_nd => item
     if (associated(x_logical2_nd%x)) nullify(x_logical2_nd%x)
     if (associated(x_logical2_nd%shape)) nullify(x_logical2_nd%shape)
  type is (logical4_nd)
     x_logical4_nd => item
     if (associated(x_logical4_nd%x)) nullify(x_logical4_nd%x)
     if (associated(x_logical4_nd%shape)) nullify(x_logical4_nd%shape)
  type is (logical8_nd)
     x_logical8_nd => item
     if (associated(x_logical8_nd%x)) nullify(x_logical8_nd%x)
     if (associated(x_logical8_nd%shape)) nullify(x_logical8_nd%shape)
  class default
     stop 'yggptr_realloc_ndarray_logical: Unexpected type.'
  end select
end subroutine yggptr_realloc_ndarray_logical
subroutine yggptr_realloc_ndarray_character(x, array_len, precision)
  implicit none
  type(yggptr) :: x
  integer(kind=c_size_t), pointer :: array_len
  integer(kind=c_size_t), pointer :: precision
  type(character_nd), pointer :: x_character_nd
  integer(kind=8) :: i
  select type(item=>x%item)
  type is (character_nd)
     x_character_nd => item
     nullify(x%data_character_unit)
     if (array_len.gt.x%len) then
        if (associated(x_character_nd%x)) then
           deallocate(x_character_nd%x)
        end if
        allocate(x_character_nd%x(array_len))
     end if
     if ((array_len.gt.x%len).or.(precision.gt.x%prec)) then
        do i = 1, size(x_character_nd%x)
           if (associated(x_character_nd%x(i)%x)) then
              deallocate(x_character_nd%x(i)%x)
           end if
           allocate(x_character_nd%x(i)%x(precision))
        end do
     end if
     if (associated(x_character_nd%shape)) nullify(x_character_nd%shape)
  class default
     stop 'yggptr_realloc_ndarray_character: Unexpected type.'
  end select
end subroutine yggptr_realloc_ndarray_character

program main
  use fygg

  ! Declare resulting variables and create buffer for received message
  logical :: timestep_calc
  logical :: ret = .true.
  type(yggcomm) :: timesync, out
  character(len=32) :: arg
  character(len=0), dimension(0) :: dtype_keys
  type(yggdtype), dimension(0) :: dtype_vals
  type(yggdtype) :: out_dtype
  real(kind=8) :: t_step, t_start, t_end, t
  character(len=32) :: t_units, model
  character(len=20), dimension(:), pointer :: keys
  type(ygggeneric) :: state_send, state_recv, msg
  real(kind=8), pointer :: x
  integer :: i

  call get_command_argument(1, arg)
  read(arg, *) t_step
  call get_command_argument(2, arg)
  read(arg, *) t_units
  call get_command_argument(3, arg)
  read(arg, *) model
  write (*, '("Hello from Fortran timesync: timestep ",F10.5," ",A3,&
       &" (model = ",A,")")') t_step, trim(t_units), trim(model)
  t_start = 0.0
  t_end = 5.0
  if (t_units.eq."hr") then
     t_end = 24.0 * t_end
  end if
  state_send = init_generic_map()
  state_recv = init_generic_map()
  ret = timestep_calc(t_start, t_units, state_send, model)
  if (.not.ret) then
     write (*, '("timesync(Fortran): Error in initial timestep &
          &calculation.")')
  end if

  ! Set up connections matching yaml
  ! Timestep synchronization connection will be 'statesync'
  timesync = ygg_timesync("statesync", t_units)
  out_dtype = create_dtype_json_object(0, dtype_keys, dtype_vals, .true.)
  out = ygg_output_type("output", out_dtype)

  ! Initialize state and synchronize with other models
  t = t_start
  ret = ygg_rpc_call(timesync, [yggarg(t), yggarg(state_send)], &
       yggarg(state_recv))
  if (.not.ret) then
     write (*, '("timesync(Fortran): Initial sync failed.")')
     stop 1
  end if
  write (*, '("timesync(Fortran): t = ",F5.1," ",A3)', advance="no") &
       t, adjustl(t_units)
  call generic_map_get_keys(state_recv, keys)
  do i = 1, size(keys)
     call generic_map_get(state_recv, trim(keys(i)), x)
     write (*, '(SP,", ",A," = ",F5.2)', advance="no") &
          trim(keys(i)), x
  end do
  write (*, '("")')

  ! Send initial state to output
  msg = copy_generic(state_recv)
  call generic_map_set(msg, "time", t, t_units)
  ret = ygg_send_var(out, yggarg(msg))
  if (.not.ret) then
     write (*, '("timesync(Fortran): Failed to send initial output &
          &for t=",F10.5,".")') t
     stop 1
  end if
  call free_generic(msg)

  ! Iterate until end
  do while (t.lt.t_end)

     ! Perform calculations to update the state
     t = t + t_step
     ret = timestep_calc(t, t_units, state_send, model)
     if (.not.ret) then
        write (*, '("timesync(Fortran): Error in timestep &
             &calculation for t = ",F10.5,".")') t
        stop 1
     end if

     ! Synchronize the state
     ret = ygg_rpc_call(timesync, [yggarg(t), yggarg(state_send)], &
          yggarg(state_recv))
     if (.not.ret) then
        write (*, '("timesync(Fortran): sync failed for t=",F10.5,&
             &".")') t
        stop 1
     end if
     write (*, '("timesync(Fortran): t = ",F5.1," ",A3)', advance="no") &
          t, adjustl(t_units)
     call generic_map_get_keys(state_recv, keys)
     do i = 1, size(keys)
        call generic_map_get(state_recv, keys(i), x)
        write (*, '(SP,", ",A," = ",F5.2)', advance="no") &
             trim(keys(i)), x
     end do
     write (*, '("")')

     ! Send output
     msg = copy_generic(state_recv)
     call generic_map_set(msg, "time", t, t_units)
     ret = ygg_send_var(out, yggarg(msg))
     if (.not.ret) then
        write (*, '("timesync(Fortran): Failed to send output for &
             &t=",F10.5,".")') t
        stop 1
     end if
     call free_generic(msg)

  end do

  write (*, '("Goodbye from Fortran timesync")')
  call free_generic(state_send)
  call free_generic(state_recv)

end program main


function timestep_calc(t, t_units, state, model) result (ret)
  use fygg
  implicit none
  real(kind=8) :: t
  character(len=*) :: t_units
  type(ygggeneric) :: state
  character(len=*) :: model
  logical :: ret
  real(kind=8) :: x_period = 10.0  ! Days
  real(kind=8) :: y_period = 5.0   ! Days
  real(kind=8) :: z_period = 20.0  ! Days
  real(kind=8) :: o_period = 2.5   ! Days
  ret = .true.
  if (t_units.eq."day") then
     ! No conversion necessary
  else if (t_units.eq."hr") then
     x_period = x_period * 24.0
     y_period = y_period * 24.0
     z_period = z_period * 24.0
     o_period = o_period * 24.0
  else
     write (*, '("timestep_calc: Unsupported unit ''",A,"''")') t_units
     ret = .false.
  end if
  if (ret) then
     if (model.eq."A") then
        call generic_map_set(state, "x", &
             sin(2.0 * PI_8 * t / x_period))
        call generic_map_set(state, "y", &
             cos(2.0 * PI_8 * t / y_period))
        call generic_map_set(state, "z1", &
             -cos(2.0 * PI_8 * t / z_period))
        call generic_map_set(state, "z2", &
             -cos(2.0 * PI_8 * t / z_period))
        call generic_map_set(state, "a", &
             sin(2.0 * PI_8 * t / o_period))
     else
        call generic_map_set(state, "xvar", &
             sin(2.0 * PI_8 * t / x_period))
        call generic_map_set(state, "yvar", &
             cos(2.0 * PI_8 * t / y_period))
        call generic_map_set(state, "z", &
             -2.0 * cos(2.0 * PI_8 * t / z_period))
        call generic_map_set(state, "b", &
             cos(2.0 * PI_8 * t / o_period))
     end if
  end if
end function timestep_calc

! Interface for getting/setting generic map elements
! Get methods
subroutine generic_map_get_generic(x, key, out)
  implicit none
  type(ygggeneric), intent(in) :: x
  character(len=*), intent(in) :: key
  type(ygggeneric), pointer, intent(out) :: out
  integer(kind=c_int) :: flag
  flag = get_generic_object(x, key, out)
  if (flag.ne.0) then
     stop "generic_map_get_generic: Error extracting generic object."
  end if
end subroutine generic_map_get_generic
subroutine generic_map_get_boolean(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  logical(kind=1), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_item(x, key, "boolean")
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_boolean
subroutine generic_map_get_integer(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=c_int), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_item(x, key, "integer")
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_integer
subroutine generic_map_get_null(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggnull), intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_item(x, key, "null")
  ! call c_f_pointer(c_out%ptr, out)
end subroutine generic_map_get_null
subroutine generic_map_get_number(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=8), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_item(x, key, "number")
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_number
subroutine generic_map_get_string(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(len=:, kind=c_char), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_item(x, key, "string")
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_string
subroutine generic_map_get_map(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggmap), pointer, intent(out) :: out
  allocate(out)
  out = yggmap(init_generic())
  out%obj = generic_map_get_item(x, key, "object")
end subroutine generic_map_get_map
subroutine generic_map_get_array(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggarr), pointer, intent(out) :: out
  allocate(out)
  out = yggarr(init_generic())
  out%obj = generic_map_get_item(x, key, "array")
end subroutine generic_map_get_array
subroutine generic_map_get_ply(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(c_ptr) :: c_out
  type(yggply), pointer, intent(out) :: out
  c_out = generic_map_get_item(x, key, "ply")
  ! Copy?
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_ply
subroutine generic_map_get_obj(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(c_ptr) :: c_out
  type(yggobj), pointer, intent(out) :: out
  c_out = generic_map_get_item(x, key, "obj")
  ! Copy?
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_obj
subroutine generic_map_get_python_class(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(c_ptr) :: c_out
  type(yggpython), pointer, intent(out) :: out
  c_out = generic_map_get_item(x, key, "class")
  ! Copy?
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_python_class
subroutine generic_map_get_python_function(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(c_ptr) :: c_out
  type(yggpython), pointer, intent(out) :: out
  c_out = generic_map_get_item(x, key, "function")
  ! Copy?
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_python_function
subroutine generic_map_get_schema(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggschema), pointer, intent(out) :: out
  allocate(out)
  out = yggschema(init_generic())
  out%obj = generic_map_get_item(x, key, "schema")
end subroutine generic_map_get_schema
subroutine generic_map_get_any(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygggeneric), pointer, intent(out) :: out
  allocate(out)
  out = init_generic()
  out%obj = generic_map_get_item(x, key, "any")
end subroutine generic_map_get_any
! Get scalar int
subroutine generic_map_get_integer2(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=2), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "int", 8 * 2)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_integer2
subroutine generic_map_get_integer4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=4), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "int", 8 * 4)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_integer4
subroutine generic_map_get_integer8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=8), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "int", 8 * 8)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_integer8
! Get scalar uint
subroutine generic_map_get_unsigned1(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint1), intent(out) :: out
  integer(kind=1), pointer :: temp
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "uint", 8 * 1)
  call c_f_pointer(c_out, temp)
  out%x = temp
  deallocate(temp)
end subroutine generic_map_get_unsigned1
subroutine generic_map_get_unsigned2(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint2), intent(out) :: out
  integer(kind=2), pointer :: temp
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "uint", 8 * 2)
  call c_f_pointer(c_out, temp)
  out%x = temp
  deallocate(temp)
end subroutine generic_map_get_unsigned2
subroutine generic_map_get_unsigned4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint4), intent(out) :: out
  integer(kind=4), pointer :: temp
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "uint", 8 * 4)
  call c_f_pointer(c_out, temp)
  out%x = temp
  deallocate(temp)
end subroutine generic_map_get_unsigned4
subroutine generic_map_get_unsigned8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint8), intent(out) :: out
  integer(kind=8), pointer :: temp
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "uint", 8 * 8)
  call c_f_pointer(c_out, temp)
  out%x = temp
  deallocate(temp)
end subroutine generic_map_get_unsigned8
! Get scalar real
subroutine generic_map_get_real4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=4), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "float", 8 * 4)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_real4
subroutine generic_map_get_real8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=8), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "float", 8 * 8)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_real8
! Get scalar complex
subroutine generic_map_get_complex4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=4), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "complex", 8 * 4)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_complex4
subroutine generic_map_get_complex8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=8), pointer, intent(out) :: out
  type(c_ptr) :: c_out
  c_out = generic_map_get_scalar(x, key, "complex", 8 * 8)
  call c_f_pointer(c_out, out)
end subroutine generic_map_get_complex8
! Get scalar string
subroutine generic_map_get_bytes(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(len=:), pointer, intent(out) :: out
  character, dimension(:), pointer :: temp
  type(c_ptr) :: c_out
  integer :: length, i
  c_out = generic_map_get_scalar(x, key, "bytes", 0)
  length = generic_map_get_item_nbytes(x, key)
  call c_f_pointer(c_out, temp, [length])
  allocate(character(len=length) :: out)
  do i = 1, length
     out(i:i) = temp(i)
  end do
  deallocate(temp)
end subroutine generic_map_get_bytes
subroutine generic_map_get_unicode(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(kind=ucs4, len=:), pointer, intent(out) :: out
  character(kind=ucs4), dimension(:), pointer :: temp
  type(c_ptr) :: c_out
  integer :: length, i
  c_out = generic_map_get_scalar(x, key, "unicode", 0)
  length = generic_map_get_item_nbytes(x, key)/4
  call c_f_pointer(c_out, temp, [length])
  allocate(character(kind=ucs4, len=length) :: out)
  do i = 1, length
     out(i:i) = temp(i)
  end do
  deallocate(temp)
end subroutine generic_map_get_unicode

! Get 1darray int
subroutine generic_map_get_1darray_integer2(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=2), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "int", 8 * 2, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_integer2
subroutine generic_map_get_1darray_integer4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=4), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "int", 8 * 4, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_integer4
subroutine generic_map_get_1darray_integer8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=8), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "int", 8 * 8, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_integer8
! Get 1darray uint
subroutine generic_map_get_1darray_unsigned1(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint1), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "uint", 8 * 1, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_unsigned1
subroutine generic_map_get_1darray_unsigned2(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint2), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "uint", 8 * 2, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_unsigned2
subroutine generic_map_get_1darray_unsigned4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint4), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "uint", 8 * 4, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_unsigned4
subroutine generic_map_get_1darray_unsigned8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint8), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "uint", 8 * 8, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_unsigned8
! Get 1darray real
subroutine generic_map_get_1darray_real4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=4), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "float", 8 * 4, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_real4
subroutine generic_map_get_1darray_real8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=8), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "float", 8 * 8, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_real8
! Get 1darray complex
subroutine generic_map_get_1darray_complex4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=4), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "complex", 8 * 4, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_complex4
subroutine generic_map_get_1darray_complex8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=8), dimension(:), pointer, intent(out) :: out
  integer(kind=c_size_t) :: c_length
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "complex", 8 * 8, c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out, [c_length])
end subroutine generic_map_get_1darray_complex8
! Get 1darray string
subroutine generic_map_get_1darray_bytes(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(len=:), dimension(:), pointer, intent(out) :: out
  character, dimension(:), pointer :: temp
  type(c_ptr), target :: c_out
  integer(kind=c_size_t) :: c_length, i
  integer :: nbytes, precision, j
  type(c_ptr), pointer :: temp_ptr
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "bytes", 0, c_out_ptr)
  nbytes = generic_map_get_item_nbytes(x, key)
  precision = nbytes/int(c_length, kind=4)
  call c_f_pointer(c_out_ptr, temp_ptr)
  call c_f_pointer(temp_ptr, temp, [nbytes])
  allocate(character(len=precision) :: out(c_length))
  do i = 1, c_length
     do j = 1, precision
        out(i)(j:j) = temp((i-1)*precision + j)
     end do
  end do
  deallocate(temp)
end subroutine generic_map_get_1darray_bytes
subroutine generic_map_get_1darray_unicode(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(kind=ucs4, len=:), dimension(:), pointer, intent(out) :: out
  character(kind=ucs4), dimension(:), pointer :: temp
  type(c_ptr), target :: c_out
  integer(kind=c_size_t) :: c_length, i
  integer :: nbytes, precision, j
  type(c_ptr), pointer :: temp_ptr
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  c_length = generic_map_get_1darray(x, key, "unicode", 0, c_out_ptr)
  nbytes = generic_map_get_item_nbytes(x, key)
  precision = nbytes/(int(c_length, kind=4)*4)
  call c_f_pointer(c_out_ptr, temp_ptr)
  call c_f_pointer(temp_ptr, temp, [nbytes/4])
  allocate(character(kind=ucs4, len=precision) :: out(c_length))
  do i = 1, c_length
     do j = 1, precision
        out(i)(j:j) = temp((i-1)*precision + j)
     end do
  end do
  deallocate(temp)
end subroutine generic_map_get_1darray_unicode

! Get ndarray int
subroutine generic_map_get_ndarray_integer2(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(integer2_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "int", 8 * 2, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_integer2
subroutine generic_map_get_ndarray_integer4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(integer4_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "int", 8 * 4, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_integer4
subroutine generic_map_get_ndarray_integer8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(integer8_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "int", 8 * 8, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_integer8
! Get ndarray uint
subroutine generic_map_get_ndarray_unsigned1(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned1_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "uint", 8 * 1, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_unsigned1
subroutine generic_map_get_ndarray_unsigned2(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned2_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "uint", 8 * 2, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_unsigned2
subroutine generic_map_get_ndarray_unsigned4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned4_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "uint", 8 * 4, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_unsigned4
subroutine generic_map_get_ndarray_unsigned8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned8_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "uint", 8 * 8, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_unsigned8
! Get ndarray real
subroutine generic_map_get_ndarray_real4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(real4_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "float", 8 * 4, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_real4
subroutine generic_map_get_ndarray_real8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(real8_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "float", 8 * 8, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_real8
! Get ndarray complex
subroutine generic_map_get_ndarray_complex4(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(complex4_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "complex", 8 * 4, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_complex4
subroutine generic_map_get_ndarray_complex8(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(complex8_nd), intent(out) :: out
  type(c_ptr), target :: c_out
  type(c_ptr), pointer :: temp
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "complex", 8 * 8, &
       c_out_ptr)
  call c_f_pointer(c_out_ptr, temp)
  call c_f_pointer(temp, out%x, out%shape)
end subroutine generic_map_get_ndarray_complex8
! Get ndarray string
subroutine generic_map_get_ndarray_character(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(character_nd), intent(out) :: out
  character, dimension(:), pointer :: temp
  type(c_ptr), target :: c_out
  integer(kind=c_size_t) :: precision, nelements, i, j
  integer(kind=c_int) :: nbytes
  type(c_ptr), pointer :: temp_ptr
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "bytes", 0, &
       c_out_ptr)
  nbytes = generic_map_get_item_nbytes(x, key)
  nelements = 1
  do i = 1, size(out%shape)
     nelements = nelements * out%shape(i)
  end do
  precision = nbytes/nelements
  call c_f_pointer(c_out_ptr, temp_ptr)
  call c_f_pointer(temp_ptr, temp, [nbytes])
  allocate(out%x(nelements))
  do i = 1, nelements
     allocate(out%x(i)%x(precision))
     do j = 1, precision
        out%x(i)%x(j) = temp((i-1)*precision + j)
     end do
  end do
  deallocate(temp)
end subroutine generic_map_get_ndarray_character
subroutine generic_map_get_ndarray_bytes(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(bytes_nd), intent(out) :: out
  character, dimension(:), pointer :: temp
  type(c_ptr), target :: c_out
  integer(kind=c_size_t) :: precision, nelements, i, j
  integer(kind=c_int) :: nbytes
  type(c_ptr), pointer :: temp_ptr
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "bytes", 0, &
       c_out_ptr)
  nbytes = generic_map_get_item_nbytes(x, key)
  nelements = 1
  do i = 1, size(out%shape)
     nelements = nelements * out%shape(i)
  end do
  precision = nbytes/nelements
  call c_f_pointer(c_out_ptr, temp_ptr)
  call c_f_pointer(temp_ptr, temp, [nbytes])
  allocate(character(len=precision) :: out%x(nelements))
  do i = 1, nelements
     do j = 1, precision
        out%x(i)(j:j) = temp(((i-1)*precision) + j)
     end do
  end do
  deallocate(temp)
end subroutine generic_map_get_ndarray_bytes
subroutine generic_map_get_ndarray_unicode(x, key, out)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unicode_nd), intent(out) :: out
  character(kind=ucs4), dimension(:), pointer :: temp
  type(c_ptr), target :: c_out
  integer(kind=c_size_t) :: precision, nelements, i, j
  integer(kind=c_int) :: nbytes
  type(c_ptr), pointer :: temp_ptr
  type(c_ptr) :: c_out_ptr
  c_out = c_null_ptr
  c_out_ptr = c_loc(c_out)
  out%shape => generic_map_get_ndarray(x, key, "unicode", 0, &
       c_out_ptr)
  nbytes = generic_map_get_item_nbytes(x, key)
  nelements = 1
  do i = 1, size(out%shape)
     nelements = nelements * out%shape(i)
  end do
  precision = nbytes/(nelements*4)
  call c_f_pointer(c_out_ptr, temp_ptr)
  call c_f_pointer(temp_ptr, temp, [nbytes/4])
  allocate(character(len=precision, kind=ucs4) :: out%x(nelements))
  do i = 1, nelements
     do j = 1, precision
        out%x(i)(j:j) = temp(((i-1)*precision) + j)
     end do
  end do
end subroutine generic_map_get_ndarray_unicode


! Set methods
subroutine generic_map_set_generic(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygggeneric), intent(in) :: val
  integer(kind=c_int) :: flag
  flag = set_generic_object(x, key, val)
  if (flag.ne.0) then
     stop "generic_map_set_generic: Error setting generic object."
  end if
end subroutine generic_map_set_generic
subroutine generic_map_set_boolean(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  logical(kind=1), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "boolean", c_val)
end subroutine generic_map_set_boolean
subroutine generic_map_set_integer(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=c_int), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "integer", c_val)
end subroutine generic_map_set_integer
subroutine generic_map_set_null(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggnull), intent(in) :: val
  type(c_ptr) :: c_val
  c_val = c_null_ptr
  call generic_map_set_item(x, key, "null", c_val)
end subroutine generic_map_set_null
subroutine generic_map_set_number(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=8), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "number", c_val)
end subroutine generic_map_set_number
subroutine generic_map_set_array(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggarr), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "array", c_val)
end subroutine generic_map_set_array
subroutine generic_map_set_map(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggmap), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "object", c_val)
end subroutine generic_map_set_map
subroutine generic_map_set_ply(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggply), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "ply", c_val)
end subroutine generic_map_set_ply
subroutine generic_map_set_obj(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggobj), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "obj", c_val)
end subroutine generic_map_set_obj
subroutine generic_map_set_python_class(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggpython), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "class", c_val)
end subroutine generic_map_set_python_class
subroutine generic_map_set_python_function(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggpython), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "function", c_val)
end subroutine generic_map_set_python_function
subroutine generic_map_set_schema(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(yggschema), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "schema", c_val)
end subroutine generic_map_set_schema
subroutine generic_map_set_any(x, key, val)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygggeneric), intent(in), target :: val
  type(c_ptr) :: c_val
  c_val = c_loc(val)
  call generic_map_set_item(x, key, "any", c_val)
end subroutine generic_map_set_any
! Set scalar int
subroutine generic_map_set_integer2(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=2), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "int", 2 * 8, units)
end subroutine generic_map_set_integer2
subroutine generic_map_set_integer4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=4), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "int", 4 * 8, units)
end subroutine generic_map_set_integer4
subroutine generic_map_set_integer8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=8), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "int", 8 * 8, units)
end subroutine generic_map_set_integer8
! Set scalar uint
subroutine generic_map_set_unsigned1(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint1), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x)
  call generic_map_set_scalar(x, key, c_val, "uint", 1 * 8, units)
end subroutine generic_map_set_unsigned1
subroutine generic_map_set_unsigned2(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint2), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x)
  call generic_map_set_scalar(x, key, c_val, "uint", 2 * 8, units)
end subroutine generic_map_set_unsigned2
subroutine generic_map_set_unsigned4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint4), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x)
  call generic_map_set_scalar(x, key, c_val, "uint", 4 * 8, units)
end subroutine generic_map_set_unsigned4
subroutine generic_map_set_unsigned8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint8), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x)
  call generic_map_set_scalar(x, key, c_val, "uint", 8 * 8, units)
end subroutine generic_map_set_unsigned8
! Set scalar real
subroutine generic_map_set_real4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=4), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "float", 4 * 8, units)
end subroutine generic_map_set_real4
subroutine generic_map_set_real8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=8), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "float", 8 * 8, units)
end subroutine generic_map_set_real8
! Set scalar complex
subroutine generic_map_set_complex4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=4), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "complex", 4 * 8, units)
end subroutine generic_map_set_complex4
subroutine generic_map_set_complex8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=8), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  call generic_map_set_scalar(x, key, c_val, "complex", 8 * 8, units)
end subroutine generic_map_set_complex8
! Set scalar string
subroutine generic_map_set_bytes(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(len=*), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  ! TODO: Convert to 1d array of characters?
  call generic_map_set_scalar(x, key, c_val, "bytes", 0, units)
end subroutine generic_map_set_bytes
subroutine generic_map_set_unicode(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(kind=ucs4, len=*), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val)
  ! TODO: Convert to 1d array of characters?
  call generic_map_set_scalar(x, key, c_val, "unicode", 0, units)
end subroutine generic_map_set_unicode

! Set 1darray int
subroutine generic_map_set_1darray_integer2(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=2), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "int", 2 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_integer2
subroutine generic_map_set_1darray_integer4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=4), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "int", 4 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_integer4
subroutine generic_map_set_1darray_integer8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  integer(kind=8), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "int", 8 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_integer8
! Set 1darray uint
subroutine generic_map_set_1darray_unsigned1(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint1), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "uint", 1 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_unsigned1
subroutine generic_map_set_1darray_unsigned2(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint2), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "uint", 2 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_unsigned2
subroutine generic_map_set_1darray_unsigned4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint4), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "uint", 4 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_unsigned4
subroutine generic_map_set_1darray_unsigned8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(ygguint8), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "uint", 8 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_unsigned8
! Set 1darray real
subroutine generic_map_set_1darray_real4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=4), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "float", 4 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_real4
subroutine generic_map_set_1darray_real8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  real(kind=8), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "float", 8 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_real8
! Set 1darray complex
subroutine generic_map_set_1darray_complex4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=4), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "complex", 4 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_complex4
subroutine generic_map_set_1darray_complex8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  complex(kind=8), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  call generic_map_set_1darray(x, key, c_val, "complex", 8 * 8, &
       size(val), units)
end subroutine generic_map_set_1darray_complex8
! Set 1darray string
subroutine generic_map_set_1darray_bytes(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(len=*), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  ! TODO: Convert to 1d array of characters?
  call generic_map_set_1darray(x, key, c_val, "bytes", 0, &
       size(val), units)
end subroutine generic_map_set_1darray_bytes
subroutine generic_map_set_1darray_unicode(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  character(kind=ucs4, len=*), dimension(:), intent(in), target :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val(1))
  ! TODO: Convert to 1d array of characters?
  call generic_map_set_1darray(x, key, c_val, "unicode", 0, &
       size(val), units)
end subroutine generic_map_set_1darray_unicode

! Set ndarray int
subroutine generic_map_set_ndarray_integer2(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(integer2_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "int", 2 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_integer2
subroutine generic_map_set_ndarray_integer4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(integer4_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "int", 4 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_integer4
subroutine generic_map_set_ndarray_integer8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(integer8_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "int", 8 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_integer8
! Get ndarray uint
subroutine generic_map_set_ndarray_unsigned1(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned1_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "uint", 1 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_unsigned1
subroutine generic_map_set_ndarray_unsigned2(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned2_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "uint", 2 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_unsigned2
subroutine generic_map_set_ndarray_unsigned4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned4_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "uint", 4 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_unsigned4
subroutine generic_map_set_ndarray_unsigned8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unsigned8_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "uint", 8 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_unsigned8
! Set ndarray real
subroutine generic_map_set_ndarray_real4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(real4_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "float", 4 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_real4
subroutine generic_map_set_ndarray_real8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(real8_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "float", 8 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_real8
! Set ndarray complex
subroutine generic_map_set_ndarray_complex4(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(complex4_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "complex", 4 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_complex4
subroutine generic_map_set_ndarray_complex8(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(complex8_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "complex", 8 * 8, &
       val%shape, units)
end subroutine generic_map_set_ndarray_complex8
! Set ndarray string
subroutine generic_map_set_ndarray_character(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(character_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x(1))
  call generic_map_set_ndarray(x, key, c_val, "bytes", 0, &
       val%shape, units)
end subroutine generic_map_set_ndarray_character
subroutine generic_map_set_ndarray_bytes(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(bytes_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x)
  call generic_map_set_ndarray(x, key, c_val, "bytes", 0, &
       val%shape, units)
end subroutine generic_map_set_ndarray_bytes
subroutine generic_map_set_ndarray_unicode(x, key, val, units_in)
  implicit none
  type(ygggeneric) :: x
  character(len=*) :: key
  type(unicode_nd), intent(in) :: val
  character(len=*), intent(in), optional, target :: units_in
  character(len=:), pointer :: units
  type(c_ptr) :: c_val
  if (present(units_in)) then
     units => units_in
  else
     allocate(character(len=0) :: units)
     units = ""
  end if
  c_val = c_loc(val%x)
  call generic_map_set_ndarray(x, key, c_val, "unicode", 0, &
       val%shape, units)
end subroutine generic_map_set_ndarray_unicode

  interface
     ! Utilities
     subroutine c_free(x) bind(c, name="ygg_c_free")
       use, intrinsic :: iso_c_binding, only: c_ptr
       implicit none
       type(c_ptr) :: x
     end subroutine c_free

     subroutine ygglog_info_c(fmt) bind(c, name="ygg_log_info_f")
       use, intrinsic :: iso_c_binding, only: c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: fmt
     end subroutine ygglog_info_c
     subroutine ygglog_debug_c(fmt) bind(c, name="ygg_log_debug_f")
       use, intrinsic :: iso_c_binding, only: c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: fmt
     end subroutine ygglog_debug_c
     subroutine ygglog_error_c(fmt) bind(c, name="ygg_log_error_f")
       use, intrinsic :: iso_c_binding, only: c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: fmt
     end subroutine ygglog_error_c
     subroutine fsleep(seconds) bind(c, name="sleep")
       use, intrinsic :: iso_c_binding, only: c_int
       integer(kind=c_int), intent(in), value :: seconds
     end subroutine fsleep

     subroutine set_global_comm() bind(c, name="set_global_comm_f")
       implicit none
     end subroutine set_global_comm
     subroutine unset_global_comm() bind(c, name="unset_global_comm_f")
       implicit none
     end subroutine unset_global_comm
  
     ! Methods for initializing channels
     function is_comm_format_array_type_c(x) result(out) &
          bind(c, name="is_comm_format_array_type_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value, intent(in) :: x
       integer(kind=c_int) :: out
     end function is_comm_format_array_type_c
     
     function ygg_output_c(name) result(channel) &
          bind(c, name="ygg_output_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_output_c
  
     function ygg_input_c(name) result(channel) &
          bind(c, name="ygg_input_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_input_c

     function ygg_output_type_c(name, datatype) result(channel) &
          bind(c, name="yggOutputType_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr), value, intent(in) :: datatype
       type(c_ptr) :: channel
     end function ygg_output_type_c
     
     function ygg_input_type_c(name, datatype) result(channel) &
          bind(c, name="yggInputType_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr), value, intent(in) :: datatype
       type(c_ptr) :: channel
     end function ygg_input_type_c
     
     function ygg_output_fmt_c(name, fmt) result(channel) &
          bind(c, name="yggOutputFmt_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: fmt
       type(c_ptr) :: channel
     end function ygg_output_fmt_c
  
     function ygg_input_fmt_c(name, fmt) result(channel) &
          bind(c, name="yggInputFmt_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: fmt
       type(c_ptr) :: channel
     end function ygg_input_fmt_c
  
     function ygg_ascii_file_output_c(name) result(channel) &
          bind(c, name="yggAsciiFileOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_ascii_file_output_c
  
     function ygg_ascii_file_input_c(name) result(channel) &
          bind(c, name="yggAsciiFileInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_ascii_file_input_c
  
     function ygg_ascii_table_output_c(name, format_str) &
          result(channel) bind(c, name="yggAsciiTableOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: format_str
       type(c_ptr) :: channel
     end function ygg_ascii_table_output_c
  
     function ygg_ascii_table_input_c(name) result(channel) &
          bind(c, name="yggAsciiTableInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_ascii_table_input_c
  
     function ygg_ascii_array_output_c(name, format_str) &
          result(channel) bind(c, name="yggAsciiArrayOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: format_str
       type(c_ptr) :: channel
     end function ygg_ascii_array_output_c
  
     function ygg_ascii_array_input_c(name) result(channel) &
          bind(c, name="yggAsciiArrayInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_ascii_array_input_c
  
     function ygg_ply_output_c(name) result(channel) &
          bind(c, name="yggPlyOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_ply_output_c
  
     function ygg_ply_input_c(name) result(channel) &
          bind(c, name="yggPlyInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_ply_input_c
  
     function ygg_obj_output_c(name) result(channel) &
          bind(c, name="yggObjOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_obj_output_c
  
     function ygg_obj_input_c(name) result(channel) &
          bind(c, name="yggObjInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_obj_input_c

     function ygg_generic_output_c(name) result(channel) &
          bind(c, name="yggGenericOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_generic_output_c
  
     function ygg_generic_input_c(name) result(channel) &
          bind(c, name="yggGenericInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_generic_input_c
  
     function ygg_any_output_c(name) result(channel) &
          bind(c, name="yggAnyOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_any_output_c
  
     function ygg_any_input_c(name) result(channel) &
          bind(c, name="yggAnyInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_any_input_c
  
     function ygg_json_array_output_c(name) result(channel) &
          bind(c, name="yggJSONArrayOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_json_array_output_c
  
     function ygg_json_array_input_c(name) result(channel) &
          bind(c, name="yggJSONArrayInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_json_array_input_c
  
     function ygg_json_object_output_c(name) result(channel) &
          bind(c, name="yggJSONObjectOutput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_json_object_output_c
  
     function ygg_json_object_input_c(name) result(channel) &
          bind(c, name="yggJSONObjectInput_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr) :: channel
     end function ygg_json_object_input_c

     function ygg_rpc_client_c(name, out_fmt, in_fmt) result(channel) &
          bind(c, name="yggRpcClient_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: out_fmt
       character(kind=c_char), dimension(*), intent(in) :: in_fmt
       type(c_ptr) :: channel
     end function ygg_rpc_client_c

     function ygg_rpc_server_c(name, in_fmt, out_fmt) result(channel) &
          bind(c, name="yggRpcServer_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: in_fmt
       character(kind=c_char), dimension(*), intent(in) :: out_fmt
       type(c_ptr) :: channel
     end function ygg_rpc_server_c

     function ygg_rpc_client_type_c(name, out_type, in_type) result(channel) &
          bind(c, name="yggRpcClientType_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr), value, intent(in) :: out_type
       type(c_ptr), value, intent(in) :: in_type
       type(c_ptr) :: channel
     end function ygg_rpc_client_type_c

     function ygg_rpc_server_type_c(name, in_type, out_type) result(channel) &
          bind(c, name="yggRpcServerType_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       type(c_ptr), value, intent(in) :: in_type
       type(c_ptr), value, intent(in) :: out_type
       type(c_ptr) :: channel
     end function ygg_rpc_server_type_c

     function ygg_timesync_c(name, t_units) result(channel) &
          bind(c, name="yggTimesync_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: name
       character(kind=c_char), dimension(*), intent(in) :: t_units
       type(c_ptr) :: channel
     end function ygg_timesync_c

     ! Method for constructing data types
     function is_dtype_format_array_c(type_struct) result(out) &
          bind(c, name="is_dtype_format_array_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value, intent(in) :: type_struct
       integer(kind=c_int) :: out
     end function is_dtype_format_array_c
     
     function create_dtype_empty_c(use_generic) result(out) &
          bind(c, name="create_dtype_empty_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_empty_c

     function create_dtype_python_c(pyobj, use_generic) result(out) &
          bind(c, name="create_dtype_python_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       type(c_ptr), value :: pyobj
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_python_c

     function create_dtype_direct_c(use_generic) result(out) &
          bind(c, name="create_dtype_direct_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_direct_c

     function create_dtype_default_c(type, use_generic) result(out) &
          bind(c, name="create_dtype_default_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: type
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_default_c

     function create_dtype_scalar_c(subtype, precision, units, &
          use_generic) result(out) &
          bind(c, name="create_dtype_scalar_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_char, c_size_t
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       character(kind=c_char), dimension(*), intent(in) :: units
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_scalar_c

     function create_dtype_1darray_c(subtype, precision, length, &
          units, use_generic) result(out) &
          bind(c, name="create_dtype_1darray_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_char, c_size_t
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       integer(kind=c_size_t), value, intent(in) :: length
       character(kind=c_char), dimension(*), intent(in) :: units
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_1darray_c

     function create_dtype_ndarray_c(subtype, precision, ndim, &
          shape, units, use_generic) result(out) &
          bind(c, name="create_dtype_ndarray_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_char, c_size_t
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       integer(kind=c_size_t), value, intent(in) :: ndim
       type(c_ptr), value, intent(in) :: shape
       character(kind=c_char), dimension(*), intent(in) :: units
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_ndarray_c

     function create_dtype_json_array_c(nitems, items, use_generic) &
          result(out) bind(c, name="create_dtype_json_array_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_size_t
       implicit none
       integer(kind=c_size_t), value, intent(in) :: nitems
       type(c_ptr), value, intent(in) :: items
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_json_array_c

     function create_dtype_json_object_c(nitems, keys, values, &
          use_generic) result(out) &
          bind(c, name="create_dtype_json_object_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_size_t
       implicit none
       integer(kind=c_size_t), value, intent(in) :: nitems
       type(c_ptr), value, intent(in) :: keys
       type(c_ptr), value, intent(in) :: values
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_json_object_c

     function create_dtype_ply_c(use_generic) result(out) &
          bind(c, name="create_dtype_ply_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_ply_c
  
     function create_dtype_obj_c(use_generic) result(out) &
          bind(c, name="create_dtype_obj_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_obj_c

     function create_dtype_format_c(format_str, as_array, use_generic) &
          result(out) bind(c, name="create_dtype_format_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_char, c_int
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: format_str
       integer(kind=c_int), value, intent(in) :: as_array
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_format_c

     function create_dtype_pyobj_c(type, use_generic) result(out) &
          bind(c, name="create_dtype_pyobj_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool, c_char
       implicit none
       character(kind=c_char), dimension(*), intent(in) :: type
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_pyobj_c

     function create_dtype_schema_c(use_generic) result(out) &
          bind(c, name="create_dtype_schema_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_schema_c
  
     function create_dtype_any_c(use_generic) result(out) &
          bind(c, name="create_dtype_any_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_bool
       implicit none
       logical(kind=c_bool), value, intent(in) :: use_generic
       type(c_ptr) :: out
     end function create_dtype_any_c
  
     ! Methods for sending/receiving
     function ygg_send_c(ygg_q, data, data_len) result (flag) &
          bind(c, name="ygg_send_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char, &
            c_int
       implicit none
       type(c_ptr), value, intent(in) :: ygg_q
       character(kind=c_char), dimension(*), intent(in) :: data
       integer(kind=c_int), value, intent(in) :: data_len
       integer(kind=c_int) :: flag
     end function ygg_send_c
  
     function ygg_recv_c(ygg_q, data, data_len) result (flag) &
          bind(c, name="ygg_recv_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char, &
            c_int
       implicit none
       type(c_ptr), value :: ygg_q
       character(kind=c_char), dimension(*) :: data
       integer(kind=c_int), value, intent(in) :: data_len
       integer(kind=c_int) :: flag
     end function ygg_recv_c

     function ygg_send_var_c(ygg_q, nargs, args) result (flag) &
          bind(c, name="ygg_send_var_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value, intent(in) :: ygg_q
       integer(kind=c_int), value :: nargs
       type(c_ptr), value :: args
       integer(kind=c_int) :: flag
     end function ygg_send_var_c

     function ygg_recv_var_c(ygg_q, nargs, args) result (flag) &
          bind(c, name="ygg_recv_var_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value :: ygg_q
       integer(kind=c_int), value :: nargs
       type(c_ptr), value :: args
       integer(kind=c_int) :: flag
     end function ygg_recv_var_c

     function ygg_recv_var_realloc_c(ygg_q, nargs, args) &
          result (flag) bind(c, name="ygg_recv_var_realloc_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value :: ygg_q
       integer(kind=c_int), value :: nargs
       type(c_ptr), value :: args
       integer(kind=c_int) :: flag
     end function ygg_recv_var_realloc_c

     function ygg_rpc_call_c(ygg_q, nargs, args) &
          result (flag) bind(c, name="rpc_call_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value :: ygg_q
       integer(kind=c_int), value :: nargs
       type(c_ptr), value :: args
       integer(kind=c_int) :: flag
     end function ygg_rpc_call_c
     
     function ygg_rpc_call_realloc_c(ygg_q, nargs, args) &
          result (flag) bind(c, name="rpc_call_realloc_f")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_int
       implicit none
       type(c_ptr), value :: ygg_q
       integer(kind=c_int), value :: nargs
       type(c_ptr), value :: args
       integer(kind=c_int) :: flag
     end function ygg_rpc_call_realloc_c
     
     ! Ply interface
     function init_ply_c() result(out) bind(c, name="init_ply_f")
       import :: yggply
       implicit none
       type(yggply) :: out
     end function init_ply_c
     subroutine free_ply_c(p) bind(c, name="free_ply_f")
       use, intrinsic :: iso_c_binding, only: c_ptr
       implicit none
       type(c_ptr), value :: p
     end subroutine free_ply_c
     function copy_ply_c(p) result(out) bind(c, name="copy_ply_f")
       import :: yggply
       implicit none
       type(yggply), value, intent(in) :: p
       type(yggply) :: out
     end function copy_ply_c
     subroutine display_ply_indent_c(p, indent) bind(c, name="display_ply_indent_f")
       use, intrinsic :: iso_c_binding, only: c_char
       import :: yggply
       implicit none
       type(yggply), value, intent(in) :: p
       character(kind=c_char), dimension(*), intent(in) :: indent
     end subroutine display_ply_indent_c
     subroutine display_ply_c(p) bind(c, name="display_ply_f")
       import :: yggply
       implicit none
       type(yggply), value, intent(in) :: p
     end subroutine display_ply_c

     ! Obj interface
     function init_obj_c() result(out) bind(c, name="init_obj_f")
       import :: yggobj
       implicit none
       type(yggobj) :: out
     end function init_obj_c
     subroutine free_obj_c(p) bind(c, name="free_obj_f")
       use, intrinsic :: iso_c_binding, only: c_ptr
       implicit none
       type(c_ptr), value :: p
     end subroutine free_obj_c
     subroutine display_obj_indent_c(p, indent) bind(c, name="display_obj_indent_f")
       use, intrinsic :: iso_c_binding, only: c_char
       import :: yggobj
       implicit none
       type(yggobj), value, intent(in) :: p
       character(kind=c_char), dimension(*), intent(in) :: indent
     end subroutine display_obj_indent_c
     function copy_obj_c(p) result(out) bind(c, name="copy_obj_f")
       import :: yggobj
       implicit none
       type(yggobj), value, intent(in) :: p
       type(yggobj) :: out
     end function copy_obj_c
     subroutine display_obj_c(p) bind(c, name="display_obj_f")
       import :: yggobj
       implicit none
       type(yggobj), value, intent(in) :: p
     end subroutine display_obj_c

     ! Generic interface
     function init_generic_c() result(out) &
          bind(c, name="init_generic_f")
       import :: ygggeneric
       implicit none
       type(ygggeneric) :: out
     end function init_generic_c
     function init_generic_array_c() result(out) &
          bind(c, name="init_generic_array_f")
       import :: ygggeneric
       implicit none
       type(ygggeneric) :: out
     end function init_generic_array_c
     function init_generic_map_c() result(out) &
          bind(c, name="init_generic_map_f")
       import :: ygggeneric
       implicit none
       type(ygggeneric) :: out
     end function init_generic_map_c
     function create_generic_c(type_class, data, nbytes) result(out) &
          bind(c, name="create_generic_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr
       import :: ygggeneric
       implicit none
       type(c_ptr), value, intent(in) :: type_class
       type(c_ptr), value, intent(in) :: data
       integer(kind=c_size_t), value, intent(in) :: nbytes
       type(ygggeneric) :: out
     end function create_generic_c
     function free_generic_c(x) result(out) &
          bind(c, name="free_generic_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_ptr
       import :: ygggeneric
       implicit none
       type(c_ptr), value :: x
       integer(kind=c_int) :: out
     end function free_generic_c
     function is_generic_init_c(x) result(out) &
          bind(c, name="is_generic_init_f")
       use, intrinsic :: iso_c_binding, only: c_int
       import :: ygggeneric
       implicit none
       type(ygggeneric), value, intent(in) :: x
       integer(kind=c_int) :: out
     end function is_generic_init_c
     function copy_generic_c(src) result(out) &
          bind(c, name="copy_generic_f")
       import :: ygggeneric
       implicit none
       type(ygggeneric), value, intent(in) :: src
       type(ygggeneric) :: out
     end function copy_generic_c
     subroutine display_generic_c(x) bind(c, name="display_generic_f")
       import :: ygggeneric
       implicit none
       type(ygggeneric), value, intent(in) :: x
     end subroutine display_generic_c
     function add_generic_array_c(arr, x) result (out) &
          bind(c, name="add_generic_array_f")
       use, intrinsic :: iso_c_binding, only: c_int
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: arr
       type(ygggeneric), value, intent(in) :: x
       integer(kind=c_int) :: out
     end function add_generic_array_c
     function set_generic_array_c(arr, i, x) result(out) &
          bind(c, name="set_generic_array_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: arr
       integer(kind=c_size_t), value, intent(in) :: i
       type(ygggeneric), value, intent(in) :: x
       integer(kind=c_int) :: out
     end function set_generic_array_c
     function get_generic_array_c(arr, i, x) result(out) &
          bind(c, name="get_generic_array_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_size_t, c_ptr
       import :: ygggeneric
       implicit none
       type(ygggeneric), value, intent(in) :: arr
       integer(kind=c_size_t), value, intent(in) :: i
       type(c_ptr), value :: x
       integer(kind=c_int) :: out
     end function get_generic_array_c
     function set_generic_object_c(arr, k, x) result(out) &
          bind(c, name="set_generic_object_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: arr
       character(kind=c_char), dimension(*), intent(in) :: k
       type(ygggeneric), value, intent(in) :: x
       integer(kind=c_int) :: out
     end function set_generic_object_c
     function get_generic_object_c(arr, k, x) result(out) &
          bind(c, name="get_generic_object_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: arr
       character(kind=c_char), dimension(*), intent(in) :: k
       type(c_ptr), value :: x
       integer(kind=c_int) :: out
     end function get_generic_object_c

     ! Python interface
     function init_python_c() result(out) &
          bind(c, name="init_python_f")
       import :: yggpython
       implicit none
       type(yggpython) :: out
     end function init_python_c
     subroutine free_python_c(x) bind(c, name="free_python_f")
       use, intrinsic :: iso_c_binding, only: c_ptr
       import :: yggpython
       implicit none
       type(c_ptr), value :: x
     end subroutine free_python_c
     function copy_python_c(x) result(out) &
          bind(c, name="copy_python_f")
       import :: yggpython
       implicit none
       type(yggpython), value :: x
       type(yggpython) :: out
     end function copy_python_c
     subroutine display_python_c(x) bind(c, name="display_python_f")
       import :: yggpython
       implicit none
       type(yggpython), value :: x
     end subroutine display_python_c

     ! Interface for getting/setting generic array elements
     function generic_array_get_size_c(x) result(out) &
          bind(c, name="generic_array_get_size_f")
       use, intrinsic :: iso_c_binding, only: c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t) :: out
     end function generic_array_get_size_c
     function generic_array_get_item_c(x, index, type) result(out) &
          bind(c, name="generic_array_get_item_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr, c_char
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       character(kind=c_char), dimension(*), intent(in) :: type
       type(c_ptr) :: out
     end function generic_array_get_item_c
     function generic_array_get_item_nbytes_c(x, index) result(out) &
          bind(c, name="generic_array_get_item_nbytes_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_int
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       integer(kind=c_int) :: out
     end function generic_array_get_item_nbytes_c
     function generic_array_get_scalar_c(x, index, subtype, precision) &
          result(out) bind(c, name="generic_array_get_scalar_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr, c_char
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       type(c_ptr) :: out
     end function generic_array_get_scalar_c
     function generic_array_get_1darray_c(x, index, subtype, &
          precision, data) result(out) &
          bind(c, name="generic_array_get_1darray_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr, c_char
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       type(c_ptr), value :: data
       integer(kind=c_size_t) :: out
     end function generic_array_get_1darray_c
     function generic_array_get_ndarray_c(x, index, subtype, &
          precision, data, shape) result(out) &
          bind(c, name="generic_array_get_ndarray_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr, c_char
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       type(c_ptr), value :: data
       type(c_ptr), value :: shape
       integer(kind=c_size_t) :: out
     end function generic_array_get_ndarray_c
     ! Set
     function generic_array_set_item_c(x, index, type, value) &
          result(out) bind(c, name="generic_array_set_item_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr, &
            c_char, c_int
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       character(kind=c_char), dimension(*), intent(in) :: type
       type(c_ptr), value :: value
       integer(kind=c_int) :: out
     end function generic_array_set_item_c
     function generic_array_set_scalar_c(x, index, value, subtype, &
          precision, units) result(out) &
          bind(c, name="generic_array_set_scalar_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr, &
            c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       type(c_ptr), value :: value
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       character(kind=c_char), dimension(*), intent(in) :: units
       integer(kind=c_int) :: out
     end function generic_array_set_scalar_c
     function generic_array_set_1darray_c(x, index, value, subtype, &
          precision, length, units) result(out) &
          bind(c, name="generic_array_set_1darray_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr, &
            c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       type(c_ptr), value :: value
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       integer(kind=c_size_t), value, intent(in) :: length
       character(kind=c_char), dimension(*), intent(in) :: units
       integer(kind=c_int) :: out
     end function generic_array_set_1darray_c
     function generic_array_set_ndarray_c(x, index, data, subtype, &
          precision, ndim, shape, units) result(out) &
          bind(c, name="generic_array_set_ndarray_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr, &
            c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t), value, intent(in) :: index
       type(c_ptr), value :: data
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       integer(kind=c_size_t), value, intent(in) :: ndim
       type(c_ptr), value, intent(in) :: shape
       character(kind=c_char), dimension(*), intent(in) :: units
       integer(kind=c_int) :: out
     end function generic_array_set_ndarray_c

     ! Interface for getting/setting generic map elements
     ! Get
     function generic_map_get_size_c(x) result(out) &
          bind(c, name="generic_map_get_size_f")
       use, intrinsic :: iso_c_binding, only: c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       integer(kind=c_size_t) :: out
     end function generic_map_get_size_c
     function generic_map_get_keys_c(x, n_keys_f, key_size_f) &
          result(out) bind(c, name="generic_map_get_keys_f")
       use, intrinsic :: iso_c_binding, only: c_size_t, c_ptr
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       type(c_ptr), value :: n_keys_f
       type(c_ptr), value :: key_size_f
       type(c_ptr) :: out
     end function generic_map_get_keys_c
     function generic_map_get_item_c(x, key, type) result(out) &
          bind(c, name="generic_map_get_item_f")
       use, intrinsic :: iso_c_binding, only: c_char, c_ptr
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       character(kind=c_char), dimension(*), intent(in) :: type
       type(c_ptr) :: out
     end function generic_map_get_item_c
     function generic_map_get_item_nbytes_c(x, key) result(out) &
          bind(c, name="generic_map_get_item_nbytes_f")
       use, intrinsic :: iso_c_binding, only: c_char, c_int
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       integer(kind=c_int) :: out
     end function generic_map_get_item_nbytes_c
     function generic_map_get_scalar_c(x, key, subtype, precision) &
          result(out) bind(c, name="generic_map_get_scalar_f")
       use, intrinsic :: iso_c_binding, only: c_char, c_ptr, c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       type(c_ptr) :: out
     end function generic_map_get_scalar_c
     function generic_map_get_1darray_c(x, key, subtype, precision, &
          data) result(out) bind(c, name="generic_map_get_1darray_f")
       use, intrinsic :: iso_c_binding, only: c_char, c_ptr, c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       type(c_ptr), value :: data
       integer(kind=c_size_t) :: out
     end function generic_map_get_1darray_c
     function generic_map_get_ndarray_c(x, key, subtype, precision, &
          data, shape) result(out) bind(c, name="generic_map_get_ndarray_f")
       use, intrinsic :: iso_c_binding, only: c_char, c_ptr, c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       type(c_ptr), value :: data
       type(c_ptr), value :: shape
       integer(kind=c_size_t) :: out
     end function generic_map_get_ndarray_c
     ! Set
     function generic_map_set_item_c(x, key, type, value) result(out) &
          bind(c, name="generic_map_set_item_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       character(kind=c_char), dimension(*), intent(in) :: type
       type(c_ptr), value :: value
       integer(kind=c_int) :: out
     end function generic_map_set_item_c
     function generic_map_set_scalar_c(x, key, value, subtype, &
          precision, units) result(out) &
          bind(c, name="generic_map_set_scalar_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr, &
            c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       type(c_ptr), value :: value
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       character(kind=c_char), dimension(*), intent(in) :: units
       integer(kind=c_int) :: out
     end function generic_map_set_scalar_c
     function generic_map_set_1darray_c(x, key, value, subtype, &
          precision, length, units) result(out) &
          bind(c, name="generic_map_set_1darray_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr, &
            c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       type(c_ptr), value :: value
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       integer(kind=c_size_t), value, intent(in) :: length
       character(kind=c_char), dimension(*), intent(in) :: units
       integer(kind=c_int) :: out
     end function generic_map_set_1darray_c
     function generic_map_set_ndarray_c(x, key, data, subtype, &
          precision, ndim, shape, units) result(out) &
          bind(c, name="generic_map_set_ndarray_f")
       use, intrinsic :: iso_c_binding, only: c_int, c_char, c_ptr, &
            c_size_t
       import :: ygggeneric
       implicit none
       type(ygggeneric), value :: x
       character(kind=c_char), dimension(*), intent(in) :: key
       type(c_ptr), value :: data
       character(kind=c_char), dimension(*), intent(in) :: subtype
       integer(kind=c_size_t), value, intent(in) :: precision
       integer(kind=c_size_t), value, intent(in) :: ndim
       type(c_ptr), value, intent(in) :: shape
       character(kind=c_char), dimension(*), intent(in) :: units
       integer(kind=c_int) :: out
     end function generic_map_set_ndarray_c

  end interface

library(yggdrasil)


timestep_calc <- function(t) {
  state = list(x=sinpi(2.0 * t / units::set_units(10.0, 'day', mode="standard")),
               y=cospi(2.0 * t / units::set_units(5.0, 'day', mode="standard")))
  return(state)
}

main <- function(t_step, t_units) {

  fprintf('Hello from R timesync: timestep = %f %s', t_step, t_units)
  t_step <- units::set_units(t_step, t_units, mode="standard")
  t_start <- units::set_units(0.0, t_units, mode="standard")
  t_end <- units::set_units(5.0, 'day', mode="standard")
  state <- timestep_calc(t_start)

  # Set up connections matching yaml
  # Timestep synchronization connection will default to 'timesync'
  timesync <- YggInterface('YggTimesync', 'timesync')
  out <- YggInterface('YggOutput', 'output')

  # Initialize state and synchronize with other models
  t <- t_start
  c(ret, state) %<-% timesync$call(t, state)
  if (!ret) {
    stop('timesync(R): Initial sync failed.')
  }
  fprintf('timesync(R): t = %5.1f %-1s, x = %+ 5.2f, y = %+ 5.2f\n',
          units::drop_units(t), units::deparse_unit(t),
	  state[['x']], state[['y']])

  # Send initial state to output
  msg = state
  msg[['time']] = t
  flag <- out$send(msg)
  if (!flag) {
    stop(sprintf('timesync(R): Failed to send initial output for t=%s', t))
  }

  # Iterate until end
  while (t < t_end) {
        
    # Perform calculations to update the state
    t <- t + t_step
    state <- timestep_calc(t)

    # Synchronize the state
    c(ret, state) %<-% timesync$call(t, state)
    if (!ret) {
      stop(sprintf('timesync(R): sync for t=%f failed.', t))
    }
    fprintf('timesync(R): t = %5.1f %-1s, x = %+ 5.2f, y = %+ 5.2f\n',
            units::drop_units(t), units::deparse_unit(t),
  	    state[['x']], state[['y']])

    # Send output
    msg = state
    msg[['time']] = t
    flag <- out$send(msg)
    if (!flag) {
      stop(sprintf('timesync(R): Failed to send output for t=%s.', t))
    }
  }

  print('Goodbye from R timesync')
  
}


args = commandArgs(trailingOnly=TRUE)
main(as.double(args[[1]]), args[[2]])

module example_module
contains
  function model_function(inputB, outputB) result(out)
    character(len=*), intent(in) :: inputB
    character(len=:), pointer :: outputB
    logical :: out
    out = .true.
    allocate(character(len=len(inputB)) :: outputB)
    outputB = inputB
    write(*, '("Model B: ",A," (length = ",I3,")")') outputB, len(outputB)
  end function model_function
end module example_module

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="maxMsg"

yaml1=
yaml2= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -a | --all )
	echo "Running Python, Matlab integration"
	yaml1='maxMsgSrv_matlab.yml'
	yaml2='maxMsgCli_python.yml'
	;;
    --all-nomatlab )
	echo "Running Python, C integration"
	yaml1='maxMsgSrv_c.yml'
	yaml2='maxMsgCli_python.yml'
	;;
    -p | --python )
	echo "Running Python"
	yaml1='maxMsgSrv_python.yml'
	yaml2='maxMsgCli_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml1='maxMsgSrv_matlab.yml'
	yaml2='maxMsgCli_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml1='maxMsgSrv_c.yml'
	yaml2='maxMsgCli_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml1='maxMsgSrv_cpp.yml'
	yaml2='maxMsgCli_cpp.yml'
	;;
    * )
	echo "Running ", $1
	yaml=$1
	;;
esac

yggrun $yaml1 $yaml2

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="SaM"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -a | --all )
	echo "Running C, Python, C++, Matlab integration"
	yaml='SaM_all.yml'
	;;
    --all-nomatlab )
	echo "Running C, Python, C++ integration"
	yaml='SaM_all_nomatlab.yml'
	;;
    -p | --python )
	echo "Running Python"
	yaml='SaM_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='SaM_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='SaM_c.yml'
	;;
    --cpp | --g++ )
	echo "Running C++"
	yaml='SaM_cpp.yml'
	;;
    * )
	echo "Running ", $1
	yaml=$1
	;;
esac

yggrun $yaml

outfile="${TMPDIR}SaM_output.txt"
cat $outfile

#!/bin/bash

# ----------------Your Commands------------------- #
case $1 in
    --root-iso )
	echo "Running Root Model w/o Interface"
	gcc -o root_isolated src/root_isolated.c
	# time for i in {1..100}; 
	# do
	time ./root_isolated ./Input/root_growth_rate.txt ./Input/init_root_mass.txt ./Input/timesteps.txt ./Output/root_output.txt
	# done
	rm root_isolated
	;;
    --shoot-iso )
	echo "Running Shoot Model w/o Interface"
	# time for i in {1..100}; 
	# do
	time python src/shoot_isolated.py ./Input/shoot_growth_rate.txt ./Input/init_shoot_mass.txt ./Input/timesteps.txt ./Input/root_output.txt ./Output/shoot_output.txt
	# done
	;;
    --root )
	echo "Running Root Model"
	time yggrun root.yml root_files.yml
	;;
    --shoot )
	echo "Running Shoot Model"
	time yggrun shoot.yml shoot_files.yml
	;;
    * )
	echo "Running Integration"
	time yggrun root.yml shoot.yml root_to_shoot.yml
	;;
esac

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="rpcFib"
export FIB_ITERATIONS="3"
export FIB_SERVER_SLEEP_SECONDS="0.01"

yaml1= 
yaml2= 
yaml3= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -a | --all )
	echo "Running Python, Matlab, C integration"
	yaml1='rpcFibSrv_c.yml'
	yaml2='rpcFibCli_python.yml'
	yaml3='rpcFibCliPar_matlab.yml'
	;;
    --all-nomatlab )
	echo "Running Python, C++, C integration"
	yaml1='rpcFibSrv_c.yml'
	yaml2='rpcFibCli_python.yml'
	yaml3='rpcFibCliPar_cpp.yml'
	;;
    -p | --python )
	echo "Running Python"
	yaml1='rpcFibSrv_python.yml'
	yaml2='rpcFibCli_python.yml'
	yaml3='rpcFibCliPar_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml1='rpcFibSrv_matlab.yml'
	yaml2='rpcFibCli_matlab.yml'
	yaml3='rpcFibCliPar_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml1='rpcFibSrv_c.yml'
	yaml2='rpcFibCli_c.yml'
	yaml3='rpcFibCliPar_c.yml'
	;;
    --cpp | --g++ )
	echo "Running C++"
	yaml1='rpcFibSrv_cpp.yml'
	yaml2='rpcFibCli_cpp.yml'
	yaml3='rpcFibCliPar_cpp.yml'
	;;
    -v | --valgrind )
	echo "Running C with valgrind"
	yaml1='rpcFibSrv_valgrind.yml'
	yaml2='rpcFibCli_valgrind.yml'
	yaml3='rpcFibCliPar_valgrind.yml'
	;;
    * )
	echo "Running ", $1
	yaml=$1
	;;
esac

yggrun $yaml1 $yaml2 $yaml3

outfile="${TMPDIR}fibCli.txt"
cat $outfile

#!/bin/bash

export YGG_DEBUG="INFO"
export YGG_NAMESPACE="model_error"

yaml= 

# ----------------Your Commands------------------- #
case $1 in
    "" | -a | --all )
	echo "Running Python, Matlab, C integration"
	yaml='model_error_all.yml'
	;;
    -p | --python )
	echo "Running Python"
	yaml='model_error_python.yml'
	;;
    -m | --matlab )
	echo "Running Matlab"
	yaml='model_error_matlab.yml'
	;;
    -c | --gcc )
	echo "Running C"
	yaml='model_error_c.yml'
	;;
    --cpp | --g++)
	echo "Running C++"
	yaml='model_error_cpp.yml'
	;;
    * )
	echo "Running ", $1
	yaml=$1
	;;
esac

yggrun $yaml

outfile="${TMPDIR}output_model_error.txt"
cat $outfile

#!/usr/bin/env bash
# Copyright 2017 Google Inc.
# All Rights Reserved.
#
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
# copyright notice, this list of conditions and the following disclaimer
# in the documentation and/or other materials provided with the
# distribution.
#     * Neither the name of Google Inc. nor the names of its
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

set -eu

if [ "${TRAVIS_OS_NAME}" != linux ]; then
    echo "Not a Linux build; skipping installation"
    exit 0
fi


if [ "${TRAVIS_SUDO}" = "true" ]; then
    echo "deb [arch=amd64] http://storage.googleapis.com/bazel-apt stable jdk1.8" | \
        sudo tee /etc/apt/sources.list.d/bazel.list
    curl https://bazel.build/bazel-release.pub.gpg | sudo apt-key add -
    sudo apt-get update && sudo apt-get install -y bazel gcc-4.9 g++-4.9 clang-3.7
elif [ "${CXX}" = "clang++" ]; then
    # Use ccache, assuming $HOME/bin is in the path, which is true in the Travis build environment.
    ln -sf /usr/bin/ccache $HOME/bin/${CXX};
    ln -sf /usr/bin/ccache $HOME/bin/${CC};
fi

#!/bin/bash

# ----------------Your Commands------------------- #
case $1 in
    -m | --matlab )
	echo "Running Python, C++, C, Matlab integration"
	yggrun canopy.yml light.yml photosynthesis.yml growth.yml fakeplant.yml
	;;
    --canopy )
	echo "Running Canopy Model"
	yggrun canopy.yml canopy_files.yml
	;;
    --light )
	echo "Running Light Model"
	yggrun light.yml light_files.yml
	;;
    --photo )
	echo "Running Photosynthesis Model"
	yggrun photosynthesis.yml photosynthesis_files.yml
	;;
    --growth-python )
	echo "Running Python Growth Model"
	yggrun growth_python.yml growth_files.yml
	;;
    --growth | --growth-matlab )
	echo "Running Matlab Growth Model"
	yggrun growth.yml growth_files.yml
	;;
    --fork )
	echo "Running Python, C++, C integration with forked output"
	yggrun canopy.yml light.yml photosynthesis.yml growth_python.yml fakeplant_fork.yml
	;;
    * )
	echo "Running Python, C++, C integration"
	yggrun canopy.yml light.yml photosynthesis.yml growth_python.yml fakeplant.yml
	;;
esac

## vX.X.X (yyyy-mm-dd)

### Bug Fixes

* Bypass adding import lines to generated function wrappers when import is not part of the parameterization for the model language driver (as in the case of Matlab).
